#include "configure.h"
#include "mfinderapp.h"
#include "functions.h"

ConfBaseIcnWin::ConfBaseIcnWin(QWidget *parent, const char *name, char *icnpath)
     			   :QWidget(parent, name)
{
	struct dirent **namelist;
	int m;

	QFont font = QFont("Helvetica", 12);
	QFont fontbig = QFont("Helvetica", 18);
	QFont fontbold = QFont("Helvetica", 12);
	fontbold.setBold(TRUE);
	setFont(font);

	QColor x = QColor(160, 164, 160);
	QColorGroup	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	QColorGroup CGinv = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	setCaption("configure");
	
	sprintf(ipath, "%s", icnpath);
	
	titlebig = new QLabel(this, "titlebig");
	titlebig->setGeometry(20, 5, 300, 29);
	titlebig->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlebig->setFont(fontbig);
	titlebig->setText("Base Icons");
	titlebig->setAlignment(265);

	titl2 = new QLabel(this, "titl2");
	titl2->setGeometry(10, 78, 80, 15);
	titl2->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl2->setFont(font);
	titl2->setText("File");
	titl2->setAlignment(290);

	pixLabFile = new QLabel(this, "pixLabFile");
	pixLabFile->setGeometry(98, 43, 50, 50);
	pixLabFile->setFrameStyle(34);
	pixLabFile->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFile->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", FIL, FALSE,
																				UNSELECT, FALSE));

	buttFile = new QPushButton(this, "buttFile");
	buttFile->setGeometry(160, 73, 50, 20);
	buttFile->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFile->setFont(font);
	buttFile->setText("change");
	connect(buttFile, SIGNAL(clicked()), SLOT(setFileIcn()));

	titl3 = new QLabel(this, "titl3");
	titl3->setGeometry(10, 133, 80, 15);
	titl3->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl3->setFont(font);
	titl3->setText("File link");
	titl3->setAlignment(290);

	pixLabFileLink = new QLabel(this, "pixLabFileLink");
	pixLabFileLink->setGeometry(98, 98, 50, 50);
	pixLabFileLink->setFrameStyle(34);
	pixLabFileLink->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFileLink->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", FILLNK,
																		 FALSE, UNSELECT, FALSE));

	buttFileLnk = new QPushButton(this, "buttFileLnk");
	buttFileLnk->setGeometry(160, 128, 50, 20);
	buttFileLnk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFileLnk->setFont(font);
	buttFileLnk->setText("change");
	connect(buttFileLnk, SIGNAL(clicked()), SLOT(setFileLnkIcn()));

	titl4 = new QLabel(this, "titl4");
	titl4->setGeometry(10, 188, 80, 15);
	titl4->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl4->setFont(font);
	titl4->setText("File exe");
	titl4->setAlignment(290);

	pixLabFileExe = new QLabel(this, "pixLabFileExe");
	pixLabFileExe->setGeometry(98, 153, 50, 50);
	pixLabFileExe->setFrameStyle(34);
	pixLabFileExe->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFileExe->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", FILEXE,
																		 FALSE, UNSELECT, FALSE));

	buttFileExe = new QPushButton(this, "buttFileExe");
	buttFileExe->setGeometry(160, 183, 50, 20);
	buttFileExe->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFileExe->setFont(font);
	buttFileExe->setText("change");
	connect(buttFileExe, SIGNAL(clicked()), SLOT(setFileExeIcn()));

	titl5 = new QLabel(this, "titl5");
	titl5->setGeometry(10, 243, 80, 15);
	titl5->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl5->setFont(font);
	titl5->setText("File exe link");
	titl5->setAlignment(290);

	pixLabFileExeLink = new QLabel(this, "pixLabFileExeLink");
	pixLabFileExeLink->setGeometry(98, 208, 50, 50);
	pixLabFileExeLink->setFrameStyle(34);
	pixLabFileExeLink->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFileExeLink->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", FILEXELNK,
																			 FALSE, UNSELECT, FALSE));

	buttFileExeLnk = new QPushButton(this, "buttFileExeLnk");
	buttFileExeLnk->setGeometry(160, 238, 50, 20);
	buttFileExeLnk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFileExeLnk->setFont(font);
	buttFileExeLnk->setText("change");
	connect(buttFileExeLnk, SIGNAL(clicked()), SLOT(setFileExeLnkIcn()));

	titl6 = new QLabel(this, "titl6");
	titl6->setGeometry(10, 298, 80, 15);
	titl6->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl6->setFont(font);
	titl6->setText("Folder");
	titl6->setAlignment(290);

	pixLabFolder = new QLabel(this, "pixLabFolder");
	pixLabFolder->setGeometry(98, 263, 50, 50);
	pixLabFolder->setFrameStyle(34);
	pixLabFolder->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFolder->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", DR, FALSE,
																				 UNSELECT, FALSE));

	buttFold = new QPushButton(this, "buttFold");
	buttFold->setGeometry(160, 293, 50, 20);
	buttFold->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFold->setFont(font);
	buttFold->setText("change");
	connect(buttFold, SIGNAL(clicked()), SLOT(setFoldIcn()));

	titl7 = new QLabel(this, "titl7");
	titl7->setGeometry(10, 353, 80, 15);
	titl7->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl7->setFont(font);
	titl7->setText("Folder link");
	titl7->setAlignment(290);

	pixLabFolderLink = new QLabel(this, "pixLabFolderLink");
	pixLabFolderLink->setGeometry(98, 318, 50, 50);
	pixLabFolderLink->setFrameStyle(34);
	pixLabFolderLink->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFolderLink->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", DRLNK,
																		 FALSE, UNSELECT, FALSE));

	buttFoldLink = new QPushButton(this, "buttFoldLink");
	buttFoldLink->setGeometry(160, 348, 50, 20);
	buttFoldLink->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFoldLink->setFont(font);
	buttFoldLink->setText("change");
	connect(buttFoldLink, SIGNAL(clicked()), SLOT(setFoldLinkIcn()));

	butOk = new QPushButton(this, "butOk");
	butOk->setGeometry(300, 395, 80, 30);
	butOk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butOk->setFont(font);
	butOk->setText("OK");
	connect(butOk, SIGNAL(clicked()), ((mfinderapp *)qApp), SLOT(makeNewReqIconList()));

	butCancel = new QPushButton(this, "butCancel");
	butCancel->setGeometry(205, 395, 80, 30);
	butCancel->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butCancel->setFont(font);
	butCancel->setText("Cancel");
	connect(butCancel, SIGNAL(clicked()), SLOT(Close()));

	pixToChangeLab = new QLabel(this, "pixToChangeLab");
	pixToChangeLab->setGeometry(283, 173, 50, 50);
	pixToChangeLab->setFrameStyle(34);
	pixToChangeLab->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	reqIcList = new QListBox(this, "reqIcList");
	reqIcList->setGeometry(235, 45, 145, 120);
	reqIcList->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	reqIcList->setFont(font);
	reqIcList->setFrameStyle(51);
	reqIcList->setLineWidth(2);
	reqIcList->setMultiSelection(FALSE);
	connect(reqIcList, SIGNAL(highlighted(const char*)), SLOT(changeIcnToChange(const char*)));
	m = scandir(ipath, &namelist, 0, alphasort);
	for(int i = 0; i < m; i++) {
		if(strcmp(namelist[i]->d_name, ".") != 0
               		&& strcmp(namelist[i]->d_name, "..") != 0) {
      	reqIcList->insertItem(namelist[i]->d_name);
		}
	}
	reqIcList->setSelected(0, TRUE);
	
	setFixedSize(400, 440);
}

ConfBaseIcnWin::~ConfBaseIcnWin()
{

}

void ConfBaseIcnWin::setFileIcn()
{
	strcpy(icnFilePath, lastPathComponent(icntochangepath));
	pixLabFile->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::setFileLnkIcn()
{
	strcpy(icnFileLnkPath, lastPathComponent(icntochangepath));
	pixLabFileLink->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::setFileExeIcn()
{
	strcpy(icnFileExePath, lastPathComponent(icntochangepath));
	pixLabFileExe->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::setFileExeLnkIcn()
{
	strcpy(icnFileExeLnkPath, lastPathComponent(icntochangepath));
	pixLabFileExeLink->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::setFoldIcn()
{
	strcpy(icnFoldPath, lastPathComponent(icntochangepath));
	pixLabFolder->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::setFoldLinkIcn()
{
	strcpy(icnFoldLnkPath, lastPathComponent(icntochangepath));
	pixLabFolderLink->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::Close()
{
	close();
}

void ConfBaseIcnWin::changeIcnToChange(const char *selname)
{
	sprintf(icntochangepath, "%s/%s", ipath, selname);
	pixToChangeLab->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::resizeEvent(QResizeEvent *)
{
	((mfinderapp *)qApp)->centreDialogOnScreen(this);
}

void ConfBaseIcnWin::paintEvent(QPaintEvent *)
{
	QPainter p;
				
	p.begin(this);
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 34, width(), 34);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 35, width(), 35);

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 383, width(), 383);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 384, width(), 384);
	p.end();
}


ConfFilesIcnWin::ConfFilesIcnWin(QWidget *parent, const char *name, 
					char *icnpath, QList<char> prefsufflist, QList<char> nameslist)
					 :QWidget(parent, name)
{
	char buff[MAX_NAME_LEN] = "";
	struct dirent **namelist;
	int m;

	QFont font = QFont("Helvetica", 12);
	QFont fontbig = QFont("Helvetica", 18);
	QFont fontbold = QFont("Helvetica", 12);
	fontbold.setBold(TRUE);
	setFont(font);

	QColor x = QColor(160, 164, 160);
	QColorGroup	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	QColorGroup CGinv = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	QColorGroup grigio = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), QColor(QRgb(6250335)), white);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	setCaption("configure");

	sprintf(ipath, "%s", icnpath);
	
	keyslist.setAutoDelete(TRUE);
	icnnamelist.setAutoDelete(TRUE);

	for(int i = 0; i < prefsufflist.count(); i++) {
		keyslist.append(new char[strlen(prefsufflist.at(i))+1]);
		strcpy(keyslist.current(), prefsufflist.at(i));
	}
	for(int i = 0; i < nameslist.count(); i++) {
		icnnamelist.append(new char[strlen(nameslist.at(i))+1]);
		strcpy(icnnamelist.current(), nameslist.at(i));
	}
	
	titlebig = new QLabel(this, "titlebig");
	titlebig->setGeometry(15, 5, 300, 30);
	titlebig->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlebig->setFont(fontbig);
	titlebig->setText("Files Icons");
	titlebig->setAlignment(265);

// ----------------------- Prefix ---------------------------
	titlpref = new QLabel(this, "titlpref");
	titlpref->setGeometry(15, 50, 80, 15);
	titlpref->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlpref->setFont(font);
	titlpref->setAlignment(292);
	titlpref->setText("Prefix");

	pixlabpref = new QLabel(this, "pixlabpref");
	pixlabpref->setGeometry(29, 188, 54, 54);
	pixlabpref->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixlabpref->setFrameStyle(34);

	prefslistbox = new QListBox(this, "prefslistbox");
	prefslistbox->setGeometry(15, 70, 80, 110);
	prefslistbox->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	prefslistbox->setFont(font);
	prefslistbox->setFrameStyle(51);
	prefslistbox->setLineWidth(2);
	prefslistbox->setMultiSelection(FALSE);
	connect(prefslistbox, SIGNAL(highlighted(const char*)), SLOT(showIconForPrefix(const char*)));
	for(int i = 0; i < keyslist.count(); i++) {
		if(keyslist.at(i)[0] != '*') {
			sprintf(buff, "");
			int j;
			for(j = 0; j < strlen(keyslist.at(i))-1; j++)
				buff[j] = keyslist.at(i)[j];
			buff[j] = '\0';
			prefslistbox->insertItem(buff);
		}
	}
	prefslistbox->setSelected(0, TRUE);

	buttchngpreficn = new QPushButton(this, "buttchngpreficn");
	buttchngpreficn->setGeometry(31, 245, 51, 20);
	buttchngpreficn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttchngpreficn->setFont(font);	
	buttchngpreficn->setText("change");
	connect(buttchngpreficn, SIGNAL(clicked()), SLOT(changeIconForPrefix()));

	buttrempreficn = new QPushButton(this, "buttrempreficn");
	buttrempreficn->setGeometry(30, 295, 51, 20);
	buttrempreficn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttrempreficn->setFont(font);		
	buttrempreficn->setText("remove");
	connect(buttrempreficn, SIGNAL(clicked()), SLOT(removePrefix()));

	prefedit = new QLineEdit(this, "prefedit");
	prefedit->setGeometry(15, 345, 80, 20);
	prefedit->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	prefedit->setFont(font);		
	prefedit->setFrame(TRUE);
	prefedit->setText("");

	buttaddpreficn = new QPushButton(this, "buttaddpreficn");
	buttaddpreficn->setGeometry(30, 370, 51, 20);
	buttaddpreficn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttaddpreficn->setFont(font);		
	buttaddpreficn->setText("add");
	connect(buttaddpreficn, SIGNAL(clicked()), SLOT(addPrefix()));

// ----------------------- Suffix ---------------------------
	titlsuff = new QLabel(this, "titlsuff");
	titlsuff->setGeometry(105, 50, 80, 15);
	titlsuff->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlsuff->setFont(font);		
	titlsuff->setAlignment(292);
	titlsuff->setText("Suffix");

	pixlabsuff = new QLabel(this, "pixlabsuff");
	pixlabsuff->setGeometry(119, 188, 54, 54);
	pixlabsuff->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixlabsuff->setFrameStyle(34);

	suffslistbox = new QListBox(this, "suffslistbox");
	suffslistbox->setGeometry(105, 70, 80, 110);
	suffslistbox->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	suffslistbox->setFont(font);	
	suffslistbox->setFrameStyle(51);
	suffslistbox->setLineWidth(2);
	suffslistbox->setMultiSelection(FALSE);
	connect(suffslistbox, SIGNAL(highlighted(const char*)), SLOT(showIconForSuffix(const char*)));
	for(int i = 0; i < keyslist.count(); i++) {
		if(keyslist.at(i)[0] == '*') {
			sprintf(buff, "");
			buff[0] = '.';
			int j;
			for(j = 1; j < strlen(keyslist.at(i)); j++)
				buff[j] = prefsufflist.at(i)[j];
			buff[j] = '\0';
			suffslistbox->insertItem(buff);
		}
	}
	suffslistbox->setSelected(0, TRUE);

	buttchngsufficn = new QPushButton(this, "buttchngsufficn");
	buttchngsufficn->setGeometry(121, 245, 51, 20);
	buttchngsufficn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttchngsufficn->setFont(font);			
	buttchngsufficn->setText("change");
	connect(buttchngsufficn, SIGNAL(clicked()), SLOT(changeIconForSuffix()));
	
	buttremsuffcn = new QPushButton(this, "buttremsuffcn");
	buttremsuffcn->setGeometry(120, 295, 51, 20);
	buttremsuffcn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttremsuffcn->setFont(font);			
	buttremsuffcn->setText("remove");
	connect(buttremsuffcn, SIGNAL(clicked()), SLOT(removeSuffix()));

	suffedit = new QLineEdit(this, "LineEdit_2");
	suffedit->setGeometry(105, 345, 80, 20);
	suffedit->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	suffedit->setFont(font);			
	suffedit->setFrame(TRUE);
	suffedit->setText("");

	buttaddsufficn = new QPushButton(this, "buttaddsufficn");
	buttaddsufficn->setGeometry(120, 370, 51, 20);
	buttaddsufficn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttaddsufficn->setFont(font);			
	buttaddsufficn->setText("add");
	connect(buttaddsufficn, SIGNAL(clicked()), SLOT(addSuffix()));

// ----------------------- New Icon ---------------------------
	titlnewicon = new QLabel(this, "titlnewicon");
	titlnewicon->setGeometry(195, 50, 120, 15);
	titlnewicon->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlnewicon->setFont(font);				
	titlnewicon->setAlignment(292);
	titlnewicon->setText("New Icon");

	pixlabnewicon = new QLabel(this, "pixlabnewicon");
	pixlabnewicon->setGeometry(227, 186, 54, 54);
	pixlabnewicon->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixlabnewicon->setFrameStyle(34);

	iconsnameslist = new QListBox(this, "iconsnameslist");
	iconsnameslist->setGeometry(195, 70, 120, 110);
	iconsnameslist->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	iconsnameslist->setFont(font);				
	iconsnameslist->setFrameStyle(51);
	iconsnameslist->setLineWidth(2);
	iconsnameslist->setMultiSelection(FALSE);
	connect(iconsnameslist, SIGNAL(highlighted(const char*)), SLOT(showNewIcon(const char*)));
	m = scandir(ipath, &namelist, 0, alphasort);
	for(int i = 0; i < m; i++) {
		if(strcmp(namelist[i]->d_name, ".") != 0
               		&& strcmp(namelist[i]->d_name, "..") != 0) {
      	iconsnameslist->insertItem(namelist[i]->d_name);
		}
	}
	iconsnameslist->setSelected(0, TRUE);

// ----------------------- Expl Labels ---------------------------
	changeexpl = new QLabel(this, "changeexpl");
	changeexpl->setGeometry(31, 270, 140, 15);
	changeexpl->setFont(font);	
	changeexpl->setPalette(QPalette(grigio, grigio, grigio));
	changeexpl->setAlignment(289);
	changeexpl->setText("Change the current icon");

	removeexpl = new QLabel(this, "removeexpl");
	removeexpl->setGeometry(25, 320, 150, 15);
	removeexpl->setFont(font);	
	removeexpl->setPalette(QPalette(grigio, grigio, grigio));
	removeexpl->setAlignment(289);
	removeexpl->setText("Remove this prefix or suffix");

	addexpl = new QLabel(this, "addexpl");
	addexpl->setGeometry(29, 395, 143, 15);
	addexpl->setFont(font);				
	addexpl->setPalette(QPalette(grigio, grigio, grigio));
	addexpl->setAlignment(289);
	addexpl->setText("Add a new prefix or suffix");

// ----------------------- OK and Cancel ---------------------------
	butOk = new QPushButton(this, "butOk");
	butOk->setGeometry(235, 440, 80, 30);
	butOk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butOk->setFont(font);			
	butOk->setText("OK");
	connect(butOk, SIGNAL(clicked()), ((mfinderapp *)qApp), SLOT(makeNewIconList()));

	butCancel = new QPushButton(this, "butCancel");
	butCancel->setGeometry(145, 440, 80, 30);
	butCancel->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butCancel->setFont(font);			
	butCancel->setText("Cancel");
	connect(butCancel, SIGNAL(clicked()), SLOT(Close()));

	setFixedSize(330,485);
}

ConfFilesIcnWin::~ConfFilesIcnWin()
{
	icnnamelist.clear();
	keyslist.clear();
}

void ConfFilesIcnWin::Close()
{
	close();
}

void ConfFilesIcnWin::showIconForPrefix(const char *pref)
{
	char buff[MAX_NAME_LEN] = "", icpath[MAX_PATH_LEN] = "";
	int i, ind = -1;
	
	strcpy(currpref, pref);	

	sprintf(buff, "%s*", pref);
	for(i = 0; i < keyslist.count(); i++)
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;
	
	sprintf(icpath, "%s/%s", ipath, icnnamelist.at(ind));
	pixlabpref->setPixmap(QPixmap(icpath, "XPM"));
}

void ConfFilesIcnWin::changeIconForPrefix()
{
	char iname[MAX_NAME_LEN] = "", buff[MAX_NAME_LEN] = "";
	int i, ind = -1;

	sprintf(iname, "%s", lastPathComponent(icntochangepath));

	sprintf(buff, "%s*", currpref);
	for(i = 0; i < keyslist.count(); i++)
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;

	icnnamelist.remove(ind);
	icnnamelist.insert(ind, new char[strlen(iname)+1]);
	strcpy(icnnamelist.current(), iname);
	showIconForPrefix(currpref);
}

void ConfFilesIcnWin::addPrefix()
{
	char err[256] = "", buff[MAX_NAME_LEN] = "", buff2[MAX_NAME_LEN] = "";
	int sel;
	bool iserr = FALSE;
	
	if(!prefedit->text()) 
		return;
	sprintf(buff, "%s", prefedit->text());
	for(int i = 0; i < strlen(buff); i++) {
		if(buff[i] == '.' && i > 0) {
			sprintf(err, "The prefix can't contain a \".\"!");
			iserr = TRUE;
		}
		if(buff[i] == ' ') {
			sprintf(err, "The prefix can't contain a space!");
			iserr = TRUE;
		}
		if(buff[i] == '/') {
			sprintf(err, "The prefix can't contain a \"/\"!");
			iserr = TRUE;
		}
		if(buff[i] == '*') {
			sprintf(err, "The prefix can't contain a \"*\"!");
			iserr = TRUE;
		}
	}		
	if(!iserr) {  
		sprintf(buff2, "%s*", buff);
		for(int i = 0; i < keyslist.count(); i++) {
			if(strcmp(buff2, keyslist.at(i)) == 0) {
				sprintf(err, "This prefix is already in use!");
				iserr = TRUE;
				dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
				dialog->exec();
				break;
			}
		} 
		if(!iserr) {
			prefslistbox->insertItem(buff);
			keyslist.append(new char[strlen(buff2)+1]);
			strcpy(keyslist.current(), buff2);
			sprintf(buff, "%s", lastPathComponent(icntochangepath));	
			icnnamelist.append(new char[strlen(buff)+1]);
			strcpy(icnnamelist.current(), buff);
			prefslistbox->setCurrentItem(prefslistbox->count()-1);
		}
	} else {
		dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
		dialog->exec();
	}
}

void ConfFilesIcnWin::removePrefix()
{
	char buff[MAX_NAME_LEN] = "";
	int i, ind = -1;

	sprintf(buff, "%s*", currpref);
	for(i = 0; i < keyslist.count(); i++) 
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;
	keyslist.remove(ind);
	icnnamelist.remove(ind);
	
	for(i = 0; i < prefslistbox->count(); i++) 
		if(strcmp(prefslistbox->text(i), currpref) == 0)
			ind = i;	
	prefslistbox->removeItem(ind);
}

void ConfFilesIcnWin::showIconForSuffix(const char *suff)
{
	char buff[MAX_NAME_LEN] = "", icpath[MAX_PATH_LEN] = "";
	int i, ind = -1;

	strcpy(currsuff, suff);	
	
	buff[0] = '*';
	for(i = 1; i < strlen(suff); i++)
		buff[i] = suff[i];
	buff[i] = '\0';
	
	for(i = 0; i < keyslist.count(); i++)
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;
	
	sprintf(icpath, "%s/%s", ipath, icnnamelist.at(ind));
	pixlabsuff->setPixmap(QPixmap(icpath, "XPM"));
}

void ConfFilesIcnWin::changeIconForSuffix()
{
	char iname[MAX_NAME_LEN] = "", buff[MAX_NAME_LEN] = "";
	int i, ind = -1;

	sprintf(iname, "%s", lastPathComponent(icntochangepath));

	buff[0] = '*';
	for(i = 1; i < strlen(currsuff); i++)
		buff[i] = currsuff[i];
	buff[i] = '\0';
	for(i = 0; i < keyslist.count(); i++)
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;

	icnnamelist.remove(ind);
	icnnamelist.insert(ind, new char[strlen(iname)+1]);
	strcpy(icnnamelist.current(), iname);
	showIconForSuffix(currsuff);
}

void ConfFilesIcnWin::addSuffix()
{
	char err[256] = "", buff[MAX_NAME_LEN] = "", buff2[MAX_NAME_LEN] = "";
	int i;
	bool iserr = FALSE;
	
	sprintf(buff, "%s", suffedit->text());
	if(buff[0] != '.') {
		sprintf(err, "The first char must be a \".\"!");
		iserr = TRUE;	
	}
	for(i = 1; i < strlen(buff); i++) {
		if(buff[i] == '.') {
			sprintf(err, "The suffix can contain only a \".\"!");
			iserr = TRUE;
		}
	}
	for(i = 0; i < strlen(buff); i++) {
		if(buff[i] == ' ') {
			sprintf(err, "The suffix can't contain a space!");
			iserr = TRUE;
		}
		if(buff[i] == '/') {
			sprintf(err, "The suffix can't contain a \"/\"!");
			iserr = TRUE;
		}
		if(buff[i] == '*') {
			sprintf(err, "The suffix can't contain a \"*\"!");
			iserr = TRUE;
		}
	}		
	if(!iserr) {
		sprintf(buff2, "%s", buff);
		buff2[0] = '*';	
		for(i = 0; i < keyslist.count(); i++) {
			if(strcmp(buff2, keyslist.at(i)) == 0) {
				sprintf(err, "This suffix is already in use!");
				iserr = TRUE;
				dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
				dialog->exec();
				break;
			}
		}
		if(!iserr) {
			suffslistbox->insertItem(buff);
			keyslist.append(new char[strlen(buff2)+1]);
			strcpy(keyslist.current(), buff2);
			sprintf(buff, "%s", lastPathComponent(icntochangepath));	
			icnnamelist.append(new char[strlen(buff)+1]);
			strcpy(icnnamelist.current(), buff);
			suffslistbox->setCurrentItem(suffslistbox->count()-1);
		}
	} else {
		dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
		dialog->exec();
		return;
	}
}

void ConfFilesIcnWin::removeSuffix()
{
	char buff[MAX_NAME_LEN] = "";
	int i, ind = -1;

	buff[0] = '*';
	for(i = 1; i < strlen(currsuff); i++)
		buff[i] = currsuff[i];
	buff[i] = '\0';
	
	for(i = 0; i < keyslist.count(); i++)
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;
		
	keyslist.remove(ind);
	icnnamelist.remove(ind);
	
	for(i = 0; i < suffslistbox->count(); i++) 
		if(strcmp(suffslistbox->text(i), currsuff) == 0)
			ind = i;	
	suffslistbox->removeItem(ind);
}

void ConfFilesIcnWin::showNewIcon(const char *selname)
{
	sprintf(icntochangepath, "%s/%s", ipath, selname);
	pixlabnewicon->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfFilesIcnWin::resizeEvent(QResizeEvent *)
{
	((mfinderapp *)qApp)->centreDialogOnScreen(this);
}

void ConfFilesIcnWin::paintEvent(QPaintEvent *)
{
	QPainter p;
				
	p.begin(this);
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 38, width(), 38);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 39, width(), 39);

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 422, width(), 422);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 423, width(), 423);
	p.end();
}

// ----------------------------------------------------------

ConfXProgramWin::ConfXProgramWin(QWidget *parent, const char *name, 
 																QList<char> sufflist, 
 																QList<char> appnameslist,
																QList<appMetaData> appmdlist)
					 :QWidget(parent, name)
{
	char buff[128] = "", appname[128] = "";
	bool found;
	int count;
	
	QFont font = QFont("Helvetica", 12);
	QFont fontbig = QFont("Helvetica", 18);
	QFont fontbold = QFont("Helvetica", 12);
	fontbold.setBold(TRUE);
	setFont(font);

	QColor x = QColor(160, 164, 160);
	QColorGroup	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	QColorGroup CGinv = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	QColorGroup grigio = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), QColor(QRgb(6250335)), white);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	setCaption("configure");

	keyslist.setAutoDelete(TRUE);
	appslist.setAutoDelete(TRUE);
	tpmlist.setAutoDelete(TRUE);
	appsmdlist.setAutoDelete(TRUE);
	
	for(int i = 0; i < sufflist.count(); i++) {
		keyslist.append(new char[strlen(sufflist.at(i))+1]);
		strcpy(keyslist.current(), sufflist.at(i));
	}
	for(int i = 0; i < appnameslist.count(); i++) {
		appslist.append(new char[strlen(appnameslist.at(i))+1]);
		strcpy(appslist.current(), appnameslist.at(i));
	}
	for(int i = 0; i < appmdlist.count(); i++) {
		appsmdlist.append(new appMetaData());
		appMetaData *apmd = appsmdlist.current();
		strcpy(apmd->name, appmdlist.at(i)->name);
		strcpy(apmd->classHintName, appmdlist.at(i)->classHintName);
		strcpy(apmd->classHintClass, appmdlist.at(i)->classHintClass);
		apmd->warnifopen = appmdlist.at(i)->warnifopen;
		apmd->maxwait = appmdlist.at(i)->maxwait;
		strcpy(apmd->keyopen, appmdlist.at(i)->keyopen);
		apmd->kctrl = appmdlist.at(i)->kctrl;
		apmd->kalt = appmdlist.at(i)->kalt;
		apmd->wmfaware = appmdlist.at(i)->wmfaware;
	}
	
	titlebig = new QLabel(this, "titlebig");
	titlebig->setGeometry(15, 5, 400, 30);
	titlebig->setFont(fontbig);	
	titlebig->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlebig->setText("X Apps");
	titlebig->setAlignment(265);

	expSuff = new QLabel(this, "expSuff");
	expSuff->setGeometry(15, 50, 80, 15);
	expSuff->setFont(font);	
	expSuff->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	expSuff->setAlignment(289);
	expSuff->setText("suffix");

	linEditSuffix = new QLineEdit(this, "linEditSuffix");
	linEditSuffix->setGeometry(15, 275, 80, 20);
	linEditSuffix->setFont(font);	
	linEditSuffix->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditSuffix->setFrame(TRUE);
	linEditSuffix->setEnabled(FALSE);

	linEditProg = new QLineEdit(this, "linEditProg");
	linEditProg->setGeometry(115, 275, 80, 20);
	linEditProg->setFont(font);	
	linEditProg->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditProg->setFrame(TRUE);
	linEditProg->setEnabled(FALSE);

	suffslistbox = new QListBox(this, "suffslistbox");
	suffslistbox->setGeometry(15, 70, 80, 195);
	suffslistbox->setFont(font);	
	suffslistbox->setPalette(QPalette(CGnorm, CGnorm, CGnorm));	
	suffslistbox->setFrameStyle(51);
	suffslistbox->setLineWidth(2);
	suffslistbox->setMultiSelection(FALSE);
	connect(suffslistbox, SIGNAL(highlighted(const char*)), SLOT(showSuffInEdField(const char*)));
	for(int i = 0; i < keyslist.count(); i++) {
		sprintf(buff, "");
		int j;
		for(j = 1; j < strlen(keyslist.at(i)); j++)
			buff[j -1] = keyslist.at(i)[j];
		buff[j -1] = '\0';
		suffslistbox->insertItem(buff);
	}
	suffslistbox->setSelected(0, TRUE);

	expApp = new QLabel(this, "expApp");
	expApp->setGeometry(115, 50, 80, 15);
	expApp->setFont(font);	
	expApp->setPalette(QPalette(CGnorm, CGnorm, CGnorm));		
	expApp->setAlignment(289);
	expApp->setText("apps");

	progslistbox = new QListBox(this, "progslistbox");
	progslistbox->setGeometry(115, 70, 80, 195);
	progslistbox->setFont(font);	
	progslistbox->setPalette(QPalette(CGnorm, CGnorm, CGnorm));	
	progslistbox->setFrameStyle(51);
	progslistbox->setLineWidth(2);
	progslistbox->setMultiSelection(FALSE);
	connect(progslistbox, SIGNAL(highlighted(const char*)), SLOT(showAppNameInEdField(const char*)));
	count = 0;
	for(int i = 0; i < appslist.count(); i++) {
		found = FALSE;
		for(int j = 0; j < count; j++) {
			if(tpmlist.at(j)) {
				if(strcmp(appslist.at(i), tpmlist.at(j)) == 0)
					found = TRUE;
			}
		}
		if(!found) {
			tpmlist.append(new char[strlen(appslist.at(i))+1]);
			sprintf(tpmlist.current(), "%s", appslist.at(i));
			count = tpmlist.count();
		}
	}
	for(int i = 0; i < tpmlist.count(); i++) 
		progslistbox->insertItem(tpmlist.at(i));

	buttChngProg = new QPushButton(this, "buttChngProg");
	buttChngProg->setGeometry(15, 305, 80, 20);
	buttChngProg->setFont(font);	
	buttChngProg->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttChngProg->setText("set app");
	connect(buttChngProg, SIGNAL(clicked()), SLOT(changeAppForSuff()));

	buttRemoveSuff = new QPushButton(this, "buttRemSuff");
	buttRemoveSuff->setGeometry(15, 335, 80, 20);
	buttRemoveSuff->setFont(font);	
	buttRemoveSuff->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttRemoveSuff->setText("remove suff");
	connect(buttRemoveSuff, SIGNAL(clicked()), SLOT(removeSuff()));

	linEditAddSuffix = new QLineEdit(this, "linEditAddSuffix");
	linEditAddSuffix->setGeometry(15, 365, 80, 20);
	linEditAddSuffix->setFont(font);	
	linEditAddSuffix->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditAddSuffix->setFrame(TRUE);
	linEditAddSuffix->setText("");

	buttAddSuff = new QPushButton(this, "buttAddSuff");
	buttAddSuff->setGeometry(15, 395, 80, 20);
	buttAddSuff->setFont(font);	
	buttAddSuff->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttAddSuff->setText("add suff");
	connect(buttAddSuff, SIGNAL(clicked()), SLOT(addSuff()));



	expAddApp = new QLabel(this, "expAddApp");
	expAddApp->setGeometry(280, 50, 75, 15);
	expAddApp->setFont(font);	
	expAddApp->setPalette(QPalette(CGnorm, CGnorm, CGnorm));		
	expAddApp->setAlignment(AlignHCenter | AlignTop);
	expAddApp->setText("add App");

	expAppName = new QLabel(this, "expAppName");
	expAppName->setGeometry(230, 68, 50, 15);
	expAppName->setFont(font);	
	expAppName->setPalette(QPalette(CGnorm, CGnorm, CGnorm));		
	expAppName->setAlignment(AlignLeft | AlignTop);
	expAppName->setText("name");

	leAppName = new QLineEdit(this, "leAppName");
	leAppName->setGeometry(230, 83, 175, 20);
	leAppName->setFont(font);	
	leAppName->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	leAppName->setFrame(TRUE);

	expAppClHiName = new QLabel(this, "expAppClHiName");
	expAppClHiName->setGeometry(230, 108, 175, 15);
	expAppClHiName->setFont(font);	
	expAppClHiName->setPalette(QPalette(CGnorm, CGnorm, CGnorm));		
	expAppClHiName->setAlignment(AlignLeft | AlignTop);
	expAppClHiName->setText("XClassHint->res_name");

	leAppClHiName = new QLineEdit(this, "leAppClHiName");
	leAppClHiName->setGeometry(230, 123, 175, 20);
	leAppClHiName->setFont(font);	
	leAppClHiName->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	leAppClHiName->setFrame(TRUE);

	expAppClHiClass = new QLabel(this, "expAppClHiClass");
	expAppClHiClass->setGeometry(230, 148, 175, 15);
	expAppClHiClass->setFont(font);	
	expAppClHiClass->setPalette(QPalette(CGnorm, CGnorm, CGnorm));		
	expAppClHiClass->setAlignment(AlignLeft | AlignTop);
	expAppClHiClass->setText("XClassHint->res_class");

	leAppClHiClass = new QLineEdit(this, "leAppClHiClass");
	leAppClHiClass->setGeometry(230, 163, 175, 20);
	leAppClHiClass->setFont(font);	
	leAppClHiClass->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	leAppClHiClass->setFrame(TRUE);

	expAppMaxWait = new QLabel(this, "expAppMaxWait");
	expAppMaxWait->setGeometry(230, 190, 120, 15);
	expAppMaxWait->setFont(font);	
	expAppMaxWait->setPalette(QPalette(CGnorm, CGnorm, CGnorm));		
	expAppMaxWait->setAlignment(AlignLeft | AlignTop);
	expAppMaxWait->setText("grab win timeout");

	leAppMaxWait = new QLineEdit(this, "leAppMaxWait");
	leAppMaxWait->setGeometry(230, 207, 30, 20);
	leAppMaxWait->setFont(font);	
	leAppMaxWait->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	leAppMaxWait->setFrame(TRUE);

	ckWarnIfOp = new QCheckBox("look if already running", this, "ckWarnIfOp");
	ckWarnIfOp->setGeometry(230, 235, 170, 20);
	ckWarnIfOp->setFont(font);	
	ckWarnIfOp->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	connect(ckWarnIfOp, SIGNAL(toggled(bool)), SLOT(abilitateOpenKeyCks(bool)));



	expModKey = new QLabel(this, "expAppMaxWait");
	expModKey->setGeometry(230, 254, 170, 15);
	expModKey->setFont(font);	
	expModKey->setPalette(QPalette(CGnorm, CGnorm, CGnorm));		
	expModKey->setAlignment(AlignLeft | AlignTop);
	expModKey->setText("key for the Open Menu");

	leModKey = new QLineEdit(this, "leModKey");
	leModKey->setGeometry(230, 272, 20, 20);
	leModKey->setFont(font);	
	leModKey->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	leModKey->setFrame(TRUE);

	ckCtrlKey = new QRadioButton("ctrl", this, "ckCtrlKey");
	ckCtrlKey->setFont(font);	
	ckCtrlKey->setPalette(QPalette(CGnorm, CGnorm, CGnorm));		
	ckCtrlKey->move(265, 269);	
	ckCtrlKey->setChecked(FALSE);
	
	ckAltKey = new QRadioButton("alt", this, "ckAltKey");
	ckAltKey->setFont(font);	
	ckAltKey->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	ckAltKey->move(310, 269);			
	ckAltKey->setChecked(FALSE);
	
	bgrModKey = new QButtonGroup(this, "bgrModKey");
	bgrModKey->setGeometry(425, 0, 10, 10);
	bgrModKey->setPalette(QPalette(CGnorm, CGnorm, CGnorm));		
	bgrModKey->setFrameStyle(0);
	bgrModKey->insert(ckCtrlKey);
	bgrModKey->insert(ckAltKey);

	ckWMFAware = new QCheckBox("WMFinder aware", this, "ckWMFAware");
	ckWMFAware->setGeometry(230, 296, 175, 20);
	ckWMFAware->setFont(font);	
	ckWMFAware->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	connect(ckWMFAware, SIGNAL(toggled(bool)), SLOT(setWMFAware(bool)));


	buttModifyProg = new QPushButton(this, "buttModifyProg");
	buttModifyProg->setGeometry(230, 323, 80, 20);
	buttModifyProg->setFont(font);	
	buttModifyProg->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttModifyProg->setText("modify app");
	connect(buttModifyProg, SIGNAL(clicked()), SLOT(modifyApp()));

	buttRemoveProg = new QPushButton(this, "buttRemoveProg");
	buttRemoveProg->setGeometry(325, 323, 80, 20);
	buttRemoveProg->setFont(font);	
	buttRemoveProg->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttRemoveProg->setText("remove app");
	connect(buttRemoveProg, SIGNAL(clicked()), SLOT(removeApp()));

	buttClearProgForm = new QPushButton(this, "buttClearProgForm");
	buttClearProgForm->setGeometry(230, 350, 80, 20);
	buttClearProgForm->setFont(font);	
	buttClearProgForm->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttClearProgForm->setText("clear form");
	connect(buttClearProgForm, SIGNAL(clicked()), SLOT(clearAppForm()));

	buttAddProg = new QPushButton(this, "buttAddProg");
	buttAddProg->setGeometry(325, 350, 80, 20);
	buttAddProg->setFont(font);	
	buttAddProg->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttAddProg->setText("add app");
	connect(buttAddProg, SIGNAL(clicked()), SLOT(addApp()));




	explDefEd = new QLabel(this, "explDefEd");
	explDefEd->setGeometry(215, 390, 205, 15);
	explDefEd->setFont(font);	
	explDefEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	explDefEd->setAlignment(289);
	explDefEd->setText("default editor");

	linEditEditor = new QLineEdit(this, "linEditEditor");
	linEditEditor->setGeometry(215, 410, 205, 20);
	linEditEditor->setFont(font);	
	linEditEditor->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditEditor->setFrame(TRUE);

	explXTerm = new QLabel(this, "explXTerm");
	explXTerm->setGeometry(215, 435, 205, 15);
	explXTerm->setFont(font);	
	explXTerm->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	explXTerm->setAlignment(289);
	explXTerm->setText("xterm cmd line");

	linEditXTerm = new QLineEdit(this, "linEditXTerm");
	linEditXTerm->setGeometry(215, 455, 205, 20);
	linEditXTerm->setFont(font);	
	linEditXTerm->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditXTerm->setFrame(TRUE);

	butOk = new QPushButton(this, "Button_1");
	butOk->setGeometry(340, 505, 80, 30);
	butOk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butOk->setFont(font);				
	butOk->setText("OK");
	connect(butOk, SIGNAL(clicked()), ((mfinderapp *)qApp), SLOT(makeNewXAppList()));

	butCancel = new QPushButton(this, "Button_2");
	butCancel->setGeometry(245, 505, 80, 30);
	butCancel->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butCancel->setFont(font);				
	butCancel->setText("cancel");
	connect(butCancel, SIGNAL(clicked()), SLOT(Close()));

	setFixedSize(435, 550);
}

ConfXProgramWin::~ConfXProgramWin()
{
	keyslist.clear();
	appslist.clear();
	tpmlist.clear();
	appsmdlist.clear();
}

void ConfXProgramWin::Close()
{
	close();
}

void ConfXProgramWin::showSuffInEdField(const char *txtsel)
{
	char buff[128] = "";
	
	linEditSuffix->setText(txtsel);
	
	sprintf(buff, "*%s", txtsel);
	for(int i = 0; i < keyslist.count(); i++) {
		if(strcmp(keyslist.at(i), buff) == 0) {
			linEditProg->setText(appslist.at(i));
			break;
		}
	}
}

void ConfXProgramWin::showAppNameInEdField(const char *txtsel)
{
	char buf[32] = "";
	
	linEditProg->setText(txtsel);
	
	for(int i = 0; i < appsmdlist.count(); i++) {
		appMetaData *apmd = appsmdlist.at(i);
		if(strcmp(apmd->name, txtsel) == 0) {
			leAppName->setText(apmd->name);
			leAppClHiName->setText(apmd->classHintName);
			leAppClHiClass->setText(apmd->classHintClass);
			ckWarnIfOp->setChecked(apmd->warnifopen ? TRUE : FALSE);
			sprintf(buf, "%i", apmd->maxwait);
			leAppMaxWait->setText(buf);
			leModKey->setText(apmd->keyopen);
			leModKey->setEnabled(apmd->warnifopen ? TRUE : FALSE);
			ckCtrlKey->setChecked(apmd->kctrl ? TRUE : FALSE);
			ckCtrlKey->setEnabled(apmd->warnifopen ? TRUE : FALSE);
			ckAltKey->setChecked(apmd->kalt ? TRUE : FALSE);
			ckAltKey->setEnabled(apmd->warnifopen ? TRUE : FALSE);
			ckWMFAware->setChecked(apmd->wmfaware ? TRUE : FALSE);
			ckWMFAware->setEnabled(apmd->warnifopen ? TRUE : FALSE);
			break;
		}
	}
}

void ConfXProgramWin::changeAppForSuff()
{
	char buff[128] = "";
	
	sprintf(buff, "*%s", linEditSuffix->text());
	for(int i = 0; i < keyslist.count(); i++) {
		if(strcmp(keyslist.at(i), buff) == 0) {
			appslist.remove(i);
			appslist.insert(i, new char[strlen(linEditProg->text())+1]);
			strcpy(appslist.current(), linEditProg->text());
			break;
		}
	}
}

void ConfXProgramWin::removeSuff()
{
	char buff[128] = "";

	sprintf(buff, "*%s", linEditSuffix->text());
	for(int i = 0; i < keyslist.count(); i++) {
		if(strcmp(keyslist.at(i), buff) == 0) {
			keyslist.remove(i);
			appslist.remove(i);
			for(int j = 0; j < suffslistbox->count(); j++) 
				if(strcmp(suffslistbox->text(j), linEditSuffix->text()) == 0)
					suffslistbox->removeItem(j);
			break;
		}
	}
}

void ConfXProgramWin::addSuff()
{
	char buff[128] = "", buff2[128] = "", err[256] = "";
	bool iserr = FALSE;

	if(strlen(linEditAddSuffix->text()) >= 2) {
		sprintf(buff, "%s", linEditAddSuffix->text());
		for(int i = 0; i < strlen(buff); i++) {
			if(buff[i] == '.') {
				sprintf(err, "The suffix can't contain a \".\"!");
				iserr = TRUE;
			}
		}
		for(int i = 0; i < strlen(buff); i++) {
			if(buff[i] == ' ') {
				sprintf(err, "The suffix can't contain a space!");
				iserr = TRUE;
			}
			if(buff[i] == '/') {
				sprintf(err, "The suffix can't contain a \"/\"!");
				iserr = TRUE;
			}
			if(buff[i] == '*') {
				sprintf(err, "The suffix can't contain a \"*\"!");
				iserr = TRUE;
			}
		}		
		if(!iserr) {
			sprintf(buff2, "*%s", buff);
			for(int i = 0; i < keyslist.count(); i++) {
				if(strcmp(buff2, keyslist.at(i)) == 0) {
					sprintf(err, "This suffix is already in use!");
					iserr = TRUE;
					dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
					dialog->exec();
					break;
				}
			}
			if(!iserr) {
				suffslistbox->insertItem(buff);
				keyslist.append(new char[strlen(buff2)+1]);
				strcpy(keyslist.current(), buff2);
				appslist.append(new char[strlen(linEditProg->text())+1]);
				strcpy(appslist.current(), linEditProg->text());
			}
		} else {
			dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
			dialog->exec();
			return;
		}
	}
}

void ConfXProgramWin::addApp()
{
	char buff[128] = "", err[256] = "";
	bool iserr = FALSE;

	sprintf(buff, "%s", leAppName->text());
	for(int i = 0; i < appslist.count(); i++) {
		if(strcmp(buff, appslist.at(i)) == 0) {
			sprintf(err, "This app is already in the list!");
			iserr = TRUE;
			break;
		}
	}
	if(!iserr) {
		if(strlen(leAppName->text()) == 0 
				|| strlen(leAppClHiName->text()) == 0
				|| strlen(leAppClHiClass->text()) == 0 
				|| strlen(leAppMaxWait->text()) == 0) {
			iserr = TRUE;
			sprintf(err, "All the fields must be completed!");
		}
		for(int i = 0; i < strlen(leAppMaxWait->text()); i++) {
			if(!isdigit(leAppMaxWait->text()[i])) {
				iserr = TRUE;
				sprintf(err, "The grab win timeout must be a number!");
				break;
			}
		}
		if(atoi(leAppMaxWait->text()) > 90) {
			iserr = TRUE;
			sprintf(err, "The max wait time is 90 secs!");
		}
		if(ckWarnIfOp->isChecked()) {
			if(strlen(leModKey->text()) == 0 || strlen(leModKey->text()) > 1) {
				iserr = TRUE;
				sprintf(err, "The value for the Open command is not valid!");
			}
			if(!ckCtrlKey->isChecked() 
									&& !ckAltKey->isChecked()
														&& !ckWMFAware->isChecked()) {
				iserr = TRUE;
				sprintf(err, "You must choose a modyfier key, ctrl or alt!");
			}
		}
	}
	if(iserr) {
		dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
		dialog->exec();
	} else {
		progslistbox->insertItem(buff);
		appslist.append(new char[strlen(buff)+1]);
		strcpy(appslist.current(), buff);
		
		appsmdlist.append(new appMetaData());
		appMetaData *apmd = appsmdlist.current();
		strcpy(apmd->name, leAppName->text());
		strcpy(apmd->classHintName, leAppClHiName->text());
		strcpy(apmd->classHintClass, leAppClHiClass->text());
		apmd->warnifopen = ckWarnIfOp->isChecked() ? TRUE : FALSE;
		apmd->maxwait = atoi(leAppMaxWait->text());
		strcpy(apmd->keyopen, leModKey->text());
		apmd->kctrl = ckCtrlKey->isChecked() ? TRUE : FALSE;
		apmd->kalt = ckAltKey->isChecked() ? TRUE : FALSE;
		apmd->wmfaware = ckWMFAware->isChecked() ? TRUE : FALSE;
	}
}

void ConfXProgramWin::modifyApp()
{
	char buff[128] = "", err[256] = "";
	bool iserr = FALSE;

	iserr = TRUE;
	sprintf(buff, "%s", leAppName->text());
	for(int i = 0; i < appslist.count(); i++) {
		if(strcmp(buff, appslist.at(i)) == 0) {
			iserr = FALSE;
			break;
		}
	}
	if(iserr)
		sprintf(err, "you can't modify an app if it is not\nalready in the list!");

	if(!iserr) {
		if(strlen(leAppName->text()) == 0 
				|| strlen(leAppClHiName->text()) == 0
				|| strlen(leAppClHiClass->text()) == 0 
				|| strlen(leAppMaxWait->text()) == 0) {
			iserr = TRUE;
			sprintf(err, "All the fields must be completed!");
		}
		for(int i = 0; i < strlen(leAppMaxWait->text()); i++) {
			if(!isdigit(leAppMaxWait->text()[i])) {
				iserr = TRUE;
				sprintf(err, "The grab win timeout must be a number!");
				break;
			}
		}
		if(atoi(leAppMaxWait->text()) > 90) {
			iserr = TRUE;
			sprintf(err, "The max wait time is 90 secs!");
		}		
		if(ckWarnIfOp->isChecked()) {
			if(strlen(leModKey->text()) == 0 || strlen(leModKey->text()) > 1) {
				iserr = TRUE;
				sprintf(err, "The value for the Open command is not valid!");
			}
			if(!ckCtrlKey->isChecked() 
									&& !ckAltKey->isChecked()
														&& !ckWMFAware->isChecked()) {
				iserr = TRUE;
				sprintf(err, "You must choose a modyfier key, ctrl or alt!");
			}
		}
	}

	if(iserr) {
		dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
		dialog->exec();
	} else {
		for(int i = 0; i < appsmdlist.count(); i++) {
			appMetaData *apmd = appsmdlist.current();
			if(strcmp(apmd->name, leAppName->text()) == 0) {
				strcpy(apmd->classHintName, leAppClHiName->text());
				strcpy(apmd->classHintClass, leAppClHiClass->text());
				apmd->warnifopen = ckWarnIfOp->isChecked() ? TRUE : FALSE;
				apmd->maxwait = atoi(leAppMaxWait->text());
				strcpy(apmd->keyopen, leModKey->text());
				apmd->kctrl = ckCtrlKey->isChecked() ? TRUE : FALSE;
				apmd->kalt = ckAltKey->isChecked() ? TRUE : FALSE;
				apmd->wmfaware = ckWMFAware->isChecked() ? TRUE : FALSE;
				
				break;
			}
		}
	}
}

void ConfXProgramWin::removeApp()
{
	for(int i = 0; i < appsmdlist.count(); i++) {
		appMetaData *apmd = appsmdlist.current();
		if(strcmp(apmd->name, leAppName->text()) == 0) {
			appsmdlist.removeRef(apmd);

			for(int j = 0; j < appslist.count(); j++) {
				if(strcmp(appslist.at(j), leAppName->text()) == 0) {
					appslist.remove(j);
					keyslist.remove(j);
					break;
				}
			}	
			for(int j = 0; j < progslistbox->count(); j++) {
				if(strcmp(progslistbox->text(j), leAppName->text()) == 0) {
					progslistbox->removeItem(j);
					break;
				}
			}
			
			clearAppForm();
			break;
		}
	}
}

void ConfXProgramWin::clearAppForm()
{
	leAppName->setText("");
	leAppClHiName->setText("");
	leAppClHiClass->setText("");
	ckWarnIfOp->setChecked(FALSE);
	leAppMaxWait->setText("");
	leModKey->setText("");
	ckCtrlKey->setChecked(FALSE);
	ckAltKey->setChecked(FALSE);
	ckWMFAware->setChecked(FALSE);
}
	
void ConfXProgramWin::abilitateOpenKeyCks(bool ischek)
{
	if(ischek) {
		leModKey->setEnabled(TRUE);
		ckCtrlKey->setEnabled(TRUE);
		ckAltKey->setEnabled(TRUE);
		ckWMFAware->setEnabled(TRUE);
	} else {
		leModKey->setEnabled(FALSE);
		ckCtrlKey->setEnabled(FALSE);
		ckAltKey->setEnabled(FALSE);
		ckWMFAware->setEnabled(FALSE);
	}
}
	
void ConfXProgramWin::setWMFAware(bool ischek)
{
	if(ischek) {
		ckWarnIfOp->setChecked(TRUE);
		ckWarnIfOp->setEnabled(FALSE);
		leModKey->setText("-");
		leModKey->setEnabled(FALSE);
		ckCtrlKey->setChecked(FALSE);
		ckCtrlKey->setEnabled(FALSE);
		ckAltKey->setChecked(FALSE);
		ckAltKey->setEnabled(FALSE);
	} else {
		ckWarnIfOp->setEnabled(TRUE);
		leModKey->setEnabled(TRUE);
		ckCtrlKey->setEnabled(TRUE);
		ckAltKey->setEnabled(TRUE);
	}
}

void ConfXProgramWin::resizeEvent(QResizeEvent *)
{
	((mfinderapp *)qApp)->centreDialogOnScreen(this);
}

void ConfXProgramWin::paintEvent(QPaintEvent *)
{
	QPainter p;
				
	p.begin(this);
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 38, width(), 38);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 39, width(), 39);

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 487, width(), 487);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 488, width(), 488);
	
// ---------------------------------------------------	
	
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(215, 58, width()-15, 58);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(216, 59, width()-15, 59);

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(219, 378, width()-16, 378);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(217, 379, width()-14, 379);
	
// -----------------------------------------------------
	
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(215, 58, 215, 379);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(216, 59, 216, 378);
	
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(width()-16, 60, width()-16, 377);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(width()-15, 59, width()-15, 379);
	
	p.end();
}










