#include "mfinderapp.h"
#include "functions.h"
#include <pwd.h>
#include <grp.h>

extern char confdir[];
extern char iconsPath[];		 	
extern char appsPath[];

char ERR[512] = "";
static char *NOERR = "noerr";
static char *NAMUSE = "This name is already in use!\n";
static char *NODEL = "You dont have write permission\nfor some elements.\n"
    "These elements were not deleted!\n";
static char *NOCOPY = "You dont have write permission\nfor some elements.\n"
    "These elements were not copied!\n";
static char *SOUCDEST = "Source and destination \nare identical!\n";
static char *SUBPATH = "The destination directory\n"
						"is a subpath of the source directory!\n";
static char *FATHRWSUB = "You can't sobstitute a directory\nwith its content!\n";
static char *DIFTYPE = "You can't sobstitute objects\nof different type!\n";
static char *SYSERR = "System Error!\n";	

#define PSIZE 4
#define PIECES ((64/PSIZE)*(64/PSIZE))

char custedit[256] = "";

void mfinderapp::fileopsErr(char *title, char *error)
{
	dialog = new Dialog(0L, title, TRUE, 0, TRUE, TRUE, FALSE, FALSE, error);
	int m = dialog->exec();
}

void mfinderapp::moveOrCopy(QStrList fileslist, char *topath, QWidget *droptarget)
{
	QStrList filesdestlist, sourcenameslist, destnameslist, toremovelist;
	char frompath[MAX_PATH_LEN] = "";
	char buff[MAX_PATH_LEN] = "";
	struct dirent **dir;
	struct stat listStat, srcstat, deststat;
	int a, m, count, lnk;
	bool samename = FALSE, noaccess = FALSE;
	char *movecopy;
	MFinderWin *sourcewin = NULL, *targetwin = NULL, *wintochange = NULL;
	FileListObj *targetlistobj = NULL;
	DialogCopy *dcopy;

	dndok	= TRUE;
	
	if(fileListDragObj != NULL)
		fileListDragObj->urlDragObj->~QUrlDrag();
	if(fileDragObj != NULL)
		fileDragObj->urlDragObj->~QUrlDrag();
	if(deskDragObj != NULL)
		deskDragObj->urlDragObj->~QUrlDrag();

	movecopy = (!isdragcopying) ? "move" : "copy";	
	
	count = fileslist.count();
	if(count == 0) {
		dndok	= FALSE;
		goto cleardnd;
	}
	sprintf(frompath, "%s", deleteLastPathComponent(fileslist.at(0)));
	if(strcmp(frompath, topath) == 0) {
		dndok	= FALSE;
		goto cleardnd;
	}
	if(strcmp(topath, "") == 0) {
		dndok	= FALSE;
		goto cleardnd;
	}
	if(strcmp(topath, fileslist.at(0)) == 0) {
		dndok	= FALSE;
		goto cleardnd;
	}
	for(int i = 0; i < count; i++) {
		if(strcmp(topath, fileslist.at(i)) == 0) {
			fileopsErr("Error", SOUCDEST);
			dndok	= FALSE;
			goto cleardnd;
		}
	}
	sprintf(buff, "%s", topath);
	while(strcmp(buff, "/") != 0) {
		for(int i = 0; i < count; i++) {
			if(strcmp(buff, fileslist.at(i)) == 0) {
				fileopsErr("Error", SUBPATH);
				dndok	= FALSE;
				goto cleardnd;
			}
		}
		sprintf(buff, "%s", deleteLastPathComponent(buff));
	}
	if(access(topath, W_OK)) {
		sprintf(ERR, "You have not write permission \n for \"%s\"!\n", topath);
		fileopsErr("Error", ERR);
		dndok	= FALSE;
		goto cleardnd;
	}
	for(int i = 0; i < count; i++) {
		sourcenameslist.append(lastPathComponent(fileslist.at(i)));
		if(strcmp(topath, "/") == 0)
			sprintf(buff, "%s%s", topath, sourcenameslist.at(i));
		else
			sprintf(buff, "%s/%s", topath, sourcenameslist.at(i));
		filesdestlist.append(buff);
	}
	m = scandir(topath, &dir, 0, alphasort);
	for(int i = 0; i < m; i++)
		destnameslist.append(dir[i]->d_name);

// ------------------------- move or copy --------------------------
	sprintf(ERR, "Are you sure that you want to %s the selected items\nfrom: %s\nto: %s\n", movecopy, frompath, topath);
	dialog = new Dialog(0L, movecopy, TRUE, 0, TRUE, TRUE, FALSE, TRUE, ERR);
	if(dialog->exec()) {
		for(int i = 0; i < count; i++) {
			for(int j = 0; j < m; j++) {
				if(strcmp(sourcenameslist.at(i), destnameslist.at(j)) == 0) {
					samename = TRUE;
					if(strcmp(topath, "/") == 0)
						sprintf(buff, "%s%s", topath, sourcenameslist.at(i));
					else
						sprintf(buff, "%s/%s", topath, sourcenameslist.at(i));
						
					lstat(fileslist.at(i), &srcstat);
					lstat(buff, &deststat);
					if(srcstat.st_mode != deststat.st_mode) {
						fileopsErr("Error", DIFTYPE);
						dndok	= FALSE;
						goto cleardnd;
					}
			
					if(isPathContainedInPath(fileslist.at(i), buff)) {
						fileopsErr("Error", FATHRWSUB);
						dndok	= FALSE;
						goto cleardnd;
					}

					toremovelist.append(buff);
				}
			}
		}
		if(samename) {
			sprintf(ERR, "Some items have the same name.\nDo you want to sobstitute them?\n");
			dialog = new Dialog(0L, movecopy, TRUE, 0, TRUE, TRUE, FALSE, TRUE, ERR);
			if(!dialog->exec()) {
				dndok	= FALSE;
				goto cleardnd;
			}
			noaccess = FALSE; 
			for(int i = 0; i < toremovelist.count(); i++) {
				lstat(toremovelist.at(i), &listStat);
				if(S_ISDIR(listStat.st_mode)) { 
					if(rdel(toremovelist.at(i), TRUE)) 
						noaccess = TRUE; 
				} else {
					if(rdel(toremovelist.at(i), FALSE)) 
						noaccess = TRUE; 
				}
			}
			if(noaccess) {
				fileopsErr("Error", NOCOPY);
				dndok	= FALSE;
				goto updatewins;
			}
		}
		noaccess = FALSE; 

		if(!isdragcopying) {  // ------------------ move --------------------
			for(int i = 0; i < count; i++) {
				if(rename(fileslist.at(i), filesdestlist.at(i))) {
					if(errno == EXDEV) {
						sprintf(ERR, "You are moving some files to a different partition...\nThe files will be copyed\n");
						dialog = new Dialog(0L, movecopy, TRUE, 0, TRUE, TRUE, FALSE, FALSE, ERR);
						int prz = dialog->exec();
						isdragcopying = TRUE;
						break;
					} else {
						noaccess = TRUE; 
					}
				}
			}
			if(!noaccess && !isdragcopying) {
				for(int i = 0; i < fileslist.count(); i++) {
					if(hasCustomIconFileAtPath(fileslist.at(i))) {
						sprintf(buff, "%s", customIconNameOfFileAtPath(fileslist.at(i)));
						unsetCustomIconOfFileAtPath(fileslist.at(i));
						setCustomIconOfFileAtPath(filesdestlist.at(i), buff);
					}
					if(hasCustomEditorFileAtPath(fileslist.at(i))) {
						sprintf(buff, "%s", editorOfFileAtPath(fileslist.at(i)));
						unsetEditorOfFileAtPath(fileslist.at(i));
						setEditorOfFileAtPath(filesdestlist.at(i), buff);
					}
				}
			} 
		}
		if(isdragcopying) {  // ------------------ copy --------------------
		
			dcopy = new DialogCopy(0L, "dcopy");
			dcopy->pbar->setTotalSteps(count);
			dcopy->pbar->setProgress(0);
			dcopy->show();
			
			for(int i = 0; i < count; i++) {

				dcopy->pbar->setProgress(i);
				dcopy->repaint();
				dcopy->titlebig->repaint();
				
				lstat(fileslist.at(i), &listStat);
				if(S_ISREG(listStat.st_mode))
					if(copyfile(fileslist.at(i), filesdestlist.at(i))) 
						noaccess = TRUE; 
				if(S_ISDIR(listStat.st_mode))
					if(copydir(fileslist.at(i), filesdestlist.at(i)))
						noaccess = TRUE; 
				if(S_ISFIFO(listStat.st_mode)) 
	  				if(mkfifo(filesdestlist.at(i), user.umask & 0666))
						noaccess = TRUE; 
				if(S_ISBLK(listStat.st_mode) || S_ISCHR(listStat.st_mode) || S_ISSOCK(listStat.st_mode)) 
	  				if(mknod(filesdestlist.at(i), user.umask & 0666, listStat.st_rdev)) 
						noaccess = TRUE; 
				if(S_ISLNK(listStat.st_mode)) {
	  				char lnk[MAXPATHLEN+1];
	  				int l = readlink(fileslist.at(i), lnk, MAXPATHLEN);
	      		lnk[l] = '\0';
	      		if(symlink(lnk, filesdestlist.at(i))) 
						noaccess = TRUE; 
      		}			
			}
			dcopy->pbar->setProgress(count);
			dcopy->close();
			
			if(!noaccess) {
				for(int i = 0; i < fileslist.count(); i++) {
					if(hasCustomIconFileAtPath(fileslist.at(i))) {
						sprintf(buff, "%s", customIconNameOfFileAtPath(fileslist.at(i)));
						unsetCustomIconOfFileAtPath(fileslist.at(i));
						setCustomIconOfFileAtPath(filesdestlist.at(i), buff);
					}
					if(hasCustomEditorFileAtPath(fileslist.at(i))) {
						sprintf(buff, "%s", editorOfFileAtPath(fileslist.at(i)));
						unsetEditorOfFileAtPath(fileslist.at(i));
						setEditorOfFileAtPath(filesdestlist.at(i), buff);
					}
				}
			}  
		}
		
		if(noaccess) {  // ------------------ gli errori --------------------
			fileopsErr("Error", NOCOPY);
			dndok	= FALSE;
			goto updatewins;
		}
	} else {  // cancel nel primo dialogo
		dndok	= FALSE;
		goto cleardnd;
	}

updatewins:
// --------- source win -----------
	if(fileListDragObj != NULL) {
		sourcewin = winAtPath(fileListDragObj->myobjsframe->myPath);
	} else if(fileDragObj != NULL) {
		sourcewin = winAtPath(fileDragObj->myPath);
	} else if(deskDragObj != NULL) {
		if(deskDragObj->ismyobj) {
			if(deskDragObj->fromlistview)
				sourcewin = winAtPath(deskDragObj->myreflistobj->myobjsframe->myPath);
			else
				sourcewin = winAtPath(deskDragObj->myPath);
		}
	}
		
// --------- target win -----------
	if(droptarget->inherits("FileObj")) {     // --------- FileObj ------------
		FileObj *fobj = (FileObj*)droptarget;
		if(fobj->isOpen)
			targetwin = winAtPath(fobj->myFullPath);

	} else if(droptarget->inherits("FileListObj")) {  // ---- FileListObj -----
		targetlistobj = (FileListObj*)droptarget;
		targetwin = targetlistobj->myobjsframe->myfwin;

	} else if(droptarget->inherits("ObjsFrame")) { // ------ ObjsFrame ------
		targetwin = ((ObjsFrame*)droptarget)->myfwin;

	} else if(droptarget->inherits("ObjsListFrame")) { // ---- ObjsListFrame ----
		targetwin = ((ObjsListFrame*)droptarget)->myfwin;

	} else if(droptarget->inherits("DeskObj")) {	// --------- DeskObj ---------
		DeskObj *dso = (DeskObj*)droptarget;
		if(dso->isOpen && !dso->isOpenLocal)
			targetwin = winAtPath(dso->myFullPath);
		if(dso->isOpenLocal) {
			targetlistobj = dso->myreflistobj;
			targetwin = targetlistobj->myobjsframe->myfwin;
		}
	}

// --------- desk objects -----------
	if(!noaccess) {
		for(int i = 0; i < toremovelist.count(); i++) {
			DeskObj *d = deskObjectAtPath(toremovelist.at(i));
			if(d) {
				if(!deskDragObj) {
					removeDeskObjFromDict(d->myFullPath);
					deskobjlist.removeRef(d);
				}
				if(deskDragObj && deskDragObj != d) {
					removeDeskObjFromDict(d->myFullPath);
					deskobjlist.removeRef(d);
				}
			}
		}
	}
	if(!isdragcopying) {
		for(int i = 0; i < count; i++) {
			DeskObj *d = deskObjectAtPath(fileslist.at(i));
			if(d) {
				for(int j = 0; j < filesdestlist.count(); j++) {
					if(strcmp(d->myName, lastPathComponent(filesdestlist.at(j))) == 0) {
						int x = d->x;
						int y = d->y;
						if(!deskDragObj) {
							removeDeskObjFromDict(d->myFullPath);
							deskobjlist.removeRef(d);
						}
						if(deskDragObj && deskDragObj != d) {
							removeDeskObjFromDict(d->myFullPath);
							deskobjlist.removeRef(d);
						}
						makeDeskObjFromDrop(filesdestlist.at(j), x, y);
					}
				}
			}
		}
	}

// --------- target win -----------
	if(targetwin) {
		if(targetwin->viewtype == BYICONS || targetwin->viewtype == BYSMICONS) {
			ObjsFrame *target = targetwin->objsframe;
			target->updateContents();
		} else {
			ObjsListFrame *target = targetwin->objslistframe;
			target->updateContents();
		}
	}

// --------- source win -----------
	if(sourcewin) {
		if(sourcewin->viewtype == BYICONS || sourcewin->viewtype == BYSMICONS) {
			sourcewin->objsframe->updateContents();
		} else {			
			sourcewin->objslistframe->updateContents();
		}
	}

// ------------ aggiorniamo le finestre spostate ---------
	if(!noaccess) {
		if(!isdragcopying) {
			for(int i = 0; i < fileslist.count(); i++)
				propagatePathChangeInWins(fileslist.at(i), filesdestlist.at(i));
		}
	}
	
cleardnd:
	sourcenameslist.clear();
	destnameslist.clear();
	filesdestlist.clear();
	toremovelist.clear();
	
	fileListDragObj = NULL;
	fileDragObj = NULL;
	deskDragObj = NULL;

	deskobjmoving = FALSE;	
	xdnddone = TRUE;	
}

void mfinderapp::propagatePathChangeInWins(char *oldpath, char *newpath)
{
	MFinderWin *win = NULL;
	char newwinpath[MAX_PATH_LEN] = "";
	bool mustchange;
	
	for(int i = 0; i < winlist.count(); i++) {
		mustchange = FALSE;
		win = winlist.at(i);
		if(strcmp(win->myPath, oldpath) == 0) {
			mustchange = TRUE;
			sprintf(newwinpath, "%s", newpath);
		} else {
			if(isPathContainedInPath(win->myPath, oldpath)) {
				mustchange = TRUE;
				sprintf(newwinpath, "%s%s", newpath, 
								subtractPathComponentToPath(win->myPath, oldpath));
			}
		}
		if(mustchange) {
			win->changePathAndPropagate(newwinpath);
		}
	}
}

void mfinderapp::newFileObject(MFinderWin *win, bool isdir)
{
	char filepath[MAX_PATH_LEN] = "";
	char filename[MAX_NAME_LEN] = "";
	struct dirent **namelist;
	int n;

	if(access(win->myPath, W_OK)) {
		sprintf(ERR, "You have not write permission \n for \"%s\"!\n", win->myPath);
		fileopsErr("Error", ERR);
		return;
	}
	if(strcmp(win->myPath, "/") == 0) 
		sprintf(filepath, "%s", win->myPath);
	else
		sprintf(filepath, "%s/", win->myPath);

	if(isdir)
		dialog = new Dialog(0L, "New Folder", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
	else
		dialog = new Dialog(0L, "New File", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");

	if(dialog->exec()) {
		sprintf(filename, "%s", dialog->editfield->text());
		for(int i = 0; i < cstrlen(filename); i++) {
			if(filename[i] == ' ' || filename[i] == '/' || filename[i] == '*'
				|| filename[i] == '(' || filename[i] == ')' || filename[i] == '['
				|| filename[i] == ']' || filename[i] == '{' || filename[i] == '}'
				|| filename[i] == '\\' || filename[i] == '<' || filename[i] == '>'
				|| filename[i] == '^' || filename[i] == '!' || filename[i] == '?'
				|| filename[i] == '$' || filename[i] == '&' || filename[i] == '#'
				|| filename[i] == '|' || filename[i] == '~' || filename[i] == '\"'
				|| filename[i] == '\'' || filename[i] == '`') {
				sprintf(ERR, "The name is not a valid name!\nIllegal use of \"%c\" !\n", filename[i]);
				fileopsErr("Error", ERR);
				return;
			}
		}
  		n = scandir(win->myPath, &namelist, 0, alphasort);
		for(int i = 0; i <= n - 1; i++) {
			if(strcmp(namelist[i]->d_name, filename) == 0) {
				fileopsErr("Error", NAMUSE);
				return;
			}
		}
		strcat(filepath, filename);

		if(isdir) {
			if(mkdir(filepath, S_IRUSR | S_IRGRP | S_IROTH | 
												S_IWUSR | S_IXUSR | S_IXGRP | S_IXOTH)) {
				fileopsErr("Error", SYSERR);
				return;
			}
		} else {
			if(create(filepath, S_IRUSR | S_IRGRP | S_IROTH | S_IWUSR)) {
				fileopsErr("Error", SYSERR);
				return;
			}
		}

		if(win->viewtype == BYNAME)
			win->objslistframe->updateContents();
		else
			win->objsframe->updateContents();
	}
}

void mfinderapp::removeFileObjects(MFinderWin *win)
{
	struct stat listStat;
	bool noaccess = FALSE;
	bool candelete = TRUE;
	MFinderWin *wintoclose = NULL;
	int wcount;
	
	if(access(win->myPath, W_OK)) {
		sprintf(ERR, "You have not write permission \n for \"%s\"!\n", win->myPath);
		fileopsErr("Error", ERR);
		return;
	}
	sprintf(ERR, "Are you sure that want to\ndelete the selected items?\n");
	dialog = new Dialog(0L, "Remove", TRUE, 0, TRUE, TRUE, FALSE, TRUE, ERR);
	if(!dialog->exec()) 
		return;

	if(win->viewtype == BYNAME) {
		ObjsListFrame *oframe = win->objslistframe;
		QList<FileListObj> selectedlist = oframe->selectedObjects();
		for(int i = 0; i < selectedlist.count(); i++) {
			FileListObj *fobj = selectedlist.at(i);
			if(access(fobj->myFullPath, W_OK)) {
				lstat(fobj->myFullPath, &listStat);
				if(S_ISLNK(listStat.st_mode))
					candelete = FALSE;
			}
			if(candelete) {
				lstat(fobj->myFullPath, &listStat);
				if(S_ISDIR(listStat.st_mode)) {
					if(rdel(fobj->myFullPath, TRUE)) {
						noaccess = TRUE;
					} else {
						if(fobj->isOpenLocal)
							fobj->CloseLocal();

						wcount = winlist.count();
						for(int n = 0; n < wcount; n++) {
							wintoclose = winlist.at(n);
							if(strcmp(wintoclose->myPath, fobj->myFullPath) == 0) {
								wintoclose->close();
								wcount--;
								n--;
							} else {
								if(isPathContainedInPath(wintoclose->myPath, fobj->myFullPath)) {
									wintoclose->close();
									wcount--;
									n--;
								}
							}
						}
					
					}
				} else {
					if(rdel(fobj->myFullPath, FALSE))
						noaccess = TRUE;
				}
				DeskObj *d = deskObjectAtPath(fobj->myFullPath);
				if(d) {
					removeDeskObjFromDict(d->myFullPath);
					deskobjlist.removeRef(d);
				}
			}
		}
		oframe->updateContents();
	} else {
		ObjsFrame *oframe = win->objsframe;
		for(int i = 0; i < oframe->list.count(); i++) {
			FileObj *fobj = oframe->list.at(i);
			if(fobj->isSelect) {
				if(access(fobj->myFullPath, W_OK)) {
					lstat(fobj->myFullPath, &listStat);
					if(S_ISLNK(listStat.st_mode))
						candelete = FALSE;
				}
				if(candelete) {
					if(fobj->isDir) {
						if(rdel(fobj->myFullPath, TRUE)) {
							noaccess = TRUE;
						} else {
						
							wcount = winlist.count();
							for(int n = 0; n < wcount; n++) {
								wintoclose = winlist.at(n);
								if(strcmp(wintoclose->myPath, fobj->myFullPath) == 0) {
									wintoclose->close();
									wcount--;
									n--;
								} else {
									if(isPathContainedInPath(wintoclose->myPath, fobj->myFullPath)) {
										wintoclose->close();
										wcount--;
										n--;
									}
								}
							}
						
						}
					} else {
						if(rdel(fobj->myFullPath, FALSE))
							noaccess = TRUE;
					}
					DeskObj *d = deskObjectAtPath(fobj->myFullPath);
					if(d) {
						removeDeskObjFromDict(d->myFullPath);
						deskobjlist.removeRef(d);
					}
				}
			}
		}
		oframe->updateContents();
	}
	
	if(noaccess) 
		fileopsErr("Error", NODEL);
}

void mfinderapp::renameFileObjects(MFinderWin *win)
{
	char newpath[MAX_PATH_LEN] = "";
	char newname[MAX_NAME_LEN] = "";
	char buff[MAX_PATH_LEN] = "";
	struct stat listStat;
	bool noaccess = FALSE;
	bool canrename = TRUE;
	bool isvalid;

	if(access(win->myPath, W_OK)) {
		sprintf(ERR, "You have not write permission \n for \"%s\"!\n", win->myPath);
		fileopsErr("Error", ERR);
		return;
	}

	if(win->viewtype == BYNAME) {
		ObjsListFrame *oframe = win->objslistframe;
		QList<FileListObj> selectedlist = oframe->selectedObjects();
		FileListObj *fobj = selectedlist.at(0);
		isvalid = TRUE;
		dialog = new Dialog(0L, "Rename", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
		dialog->editfield->setText(fobj->myName);
		if(!dialog->exec()) 
			return;
		sprintf(newname, "%s", dialog->editfield->text());
		for(int h = 0; h < strlen(newname); h++) {
			if(newname[h] == ' ' || newname[h] == '/' || newname[h] == '*'
				|| newname[h] == '(' || newname[h] == ')' || newname[h] == '['
				|| newname[h] == ']' || newname[h] == '{' || newname[h] == '}'
				|| newname[h] == '\\' || newname[h] == '<' || newname[h] == '>'
				|| newname[h] == '^' || newname[h] == '!' || newname[h] == '?'
				|| newname[h] == '$' || newname[h] == '&' || newname[h] == '#'
				|| newname[h] == '|' || newname[h] == '~' || newname[h] == '\"'
				|| newname[h] == '\'' || newname[h] == '`') {
				isvalid = FALSE;
				sprintf(ERR, "The name is not a valid name!\nIllegal use of \"%c\" !\n", newname[h]);
				dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, ERR);
				dialog->exec();
				return;
			}
		} 			
		if(isvalid) {
			for(int h = 0; h < oframe->list.count(); h++) {
				if(strcmp(oframe->list.at(h)->myName, newname) == 0) {
					isvalid = FALSE;
					sprintf(ERR, "This name is already in use!\n");
					dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE,FALSE, FALSE, ERR);
					dialog->exec();									
					return;
				}					
			}
		}
		if(isvalid) {
			if(strcmp(fobj->myPath, "/") == 0) 
				sprintf(newpath, "%s%s", fobj->myPath, newname);
			else
				sprintf(newpath, "%s/%s", fobj->myPath, newname);
			if(rename(fobj->myFullPath, newpath)) {
				sprintf(ERR, "You don't have write access\nfor some elements!\n");
				dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, ERR);
				dialog->exec();									
				return;
			}
		}
		if(fobj->isOpenLocal)
			fobj->CloseLocal();
		propagatePathChangeInWins(fobj->myFullPath, newpath);
		DeskObj *d = deskObjectAtPath(fobj->myFullPath);
		if(d) {
			int x = d->x;
			int y = d->y;
			removeDeskObjFromDict(d->myFullPath);
			deskobjlist.removeRef(d);
			makeDeskObjFromDrop(newpath, x, y);
		}
		oframe->updateContents();
	} else {
		ObjsFrame *oframe = win->objsframe;
		for(int i = 0; i < oframe->list.count(); i++) {
			FileObj *fobj = oframe->list.at(i);
			if(fobj->isSelect) {
				isvalid = TRUE;
				dialog = new Dialog(0L, "Rename", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
				dialog->editfield->setText(fobj->myName);
				if(!dialog->exec()) 
					return;
				sprintf(newname, "%s", dialog->editfield->text());
				for(int h = 0; h < strlen(newname); h++) {
					if(newname[h] == ' ' || newname[h] == '/' || newname[h] == '*'
						|| newname[h] == '(' || newname[h] == ')' || newname[h] == '['
						|| newname[h] == ']' || newname[h] == '{' || newname[h] == '}'
						|| newname[h] == '\\' || newname[h] == '<' || newname[h] == '>'
						|| newname[h] == '^' || newname[h] == '!' || newname[h] == '?'
						|| newname[h] == '$' || newname[h] == '&' || newname[h] == '#'
						|| newname[h] == '|' || newname[h] == '~' || newname[h] == '\"'
						|| newname[h] == '\'' || newname[h] == '`') {
						isvalid = FALSE;
						sprintf(ERR, "The name is not a valid name!\nIllegal use of \"%c\" !\n", newname[h]);
						dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, ERR);
						dialog->exec();
						return;
					}
				} 			
				if(isvalid) {
					for(int h = 0; h < oframe->list.count(); h++) {
						if(strcmp(oframe->list.at(h)->myName, newname) == 0) {
							isvalid = FALSE;
							sprintf(ERR, "This name is already in use!\n");
							dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE,FALSE, FALSE, ERR);
							dialog->exec();									
							return;
						}					
					}
				}
				if(isvalid) {
					if(strcmp(fobj->myPath, "/") == 0) 
						sprintf(newpath, "%s%s", fobj->myPath, newname);
					else
						sprintf(newpath, "%s/%s", fobj->myPath, newname);
					if(rename(fobj->myFullPath, newpath)) {
						sprintf(ERR, "You don't have write access\nfor some elements!\n");
						dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, ERR);
						dialog->exec();									
						return;
					}
				}
				propagatePathChangeInWins(fobj->myFullPath, newpath);
				DeskObj *d = deskObjectAtPath(fobj->myFullPath);
				if(d) {
					int x = d->x;
					int y = d->y;
					removeDeskObjFromDict(d->myFullPath);
					deskobjlist.removeRef(d);
					makeDeskObjFromDrop(newpath, x, y);
				}
				oframe->updateContents();
				break;
			}
		}
	}
}

void mfinderapp::duplicateFileObjects(MFinderWin *win)
{
	QStrList nameslist;
	char newpath[MAX_PATH_LEN] = "";
	ObjsListFrame *olstframe;
	ObjsFrame *oframe;
	struct stat listStat;
	struct dirent **namelist;
	int lnk, n;
	bool noaccess = FALSE, somename = FALSE; 

	if(access(win->myPath, W_OK)) {
		sprintf(ERR, "You have not write permission \n for \"%s\"!\n", win->myPath);
		fileopsErr("Error", ERR);
		return;
	}
	if(win->viewtype == BYNAME) {
		olstframe = win->objslistframe;
		QList<FileListObj> selectedlist = olstframe->selectedObjects();
		for(int i = 0; i < selectedlist.count(); i++) 
			nameslist.append(selectedlist.at(i)->myFullPath);
	} else {
		oframe = win->objsframe;
		for(int i = 0; i < oframe->list.count(); i++) {
			FileObj *fobj = oframe->list.at(i);
			if(fobj->isSelect) 
				nameslist.append(fobj->myFullPath);			
		}
	}

	for(int i = 0; i < nameslist.count(); i++) {
		sprintf(newpath, "%s", nameslist.at(i));
 		n = scandir(win->myPath, &namelist, 0, alphasort);
		while(1) {
			strcat(newpath, "_copy");
			somename = FALSE;
			for(int j = 0; j <= n - 1; j++) 
				if(strcmp(namelist[j]->d_name, lastPathComponent(newpath)) == 0)
					somename = TRUE;
			if(!somename)
				break;
		}
		lstat(nameslist.at(i), &listStat);
		if(S_ISREG(listStat.st_mode))
			if(copyfile(nameslist.at(i), newpath)) 
				noaccess = TRUE; 
		if(S_ISDIR(listStat.st_mode))
			if(copydir(nameslist.at(i), newpath))
				noaccess = TRUE; 
		if(S_ISFIFO(listStat.st_mode)) 
	  		if(mkfifo(newpath, user.umask & 0666))
				noaccess = TRUE; 
		if(S_ISBLK(listStat.st_mode) || S_ISCHR(listStat.st_mode) || S_ISSOCK(listStat.st_mode)) 
	  		if(mknod(newpath, user.umask & 0666, listStat.st_rdev)) 
				noaccess = TRUE; 
		if(S_ISLNK(listStat.st_mode)) {
	  		char lnk[MAXPATHLEN+1];
	  		int l = readlink(nameslist.at(i), lnk, MAXPATHLEN);
	      lnk[l] = '\0';
	      if(symlink(lnk, newpath)) 
				noaccess = TRUE; 
      }			
	}
	if(noaccess)
		fileopsErr("Error", NOCOPY);

	if(win->viewtype == BYNAME)
		olstframe->updateContents();
	else
		oframe->updateContents();
}

void mfinderapp::Edit(MFinderWin *win)
{
	if(win->viewtype == BYNAME) {
		ObjsListFrame *oframe = win->objslistframe;
		QList<FileListObj> selectedlist = oframe->selectedObjects();
		for(int i = 0; i < selectedlist.count(); i++) {
			FileListObj *fobj = selectedlist.at(i);
			if(fobj->myType != DR &&  fobj->myType != DRLNK && 
								fobj->myType != FILLNK && fobj->myType != FILEXELNK) {
				chdir(fobj->myPath);	
				ExecComm(Editor, fobj->myFullPath);
				chdir(confdir);
			}
		}
	} else {
		ObjsFrame *oframe = win->objsframe;
		for(int i = 0; i < oframe->list.count(); i++) {
			FileObj *fobj = oframe->list.at(i);
			if(fobj->isSelect) {
				if(fobj->myType != DR &&  fobj->myType != DRLNK && 
								fobj->myType != FILLNK && fobj->myType != FILEXELNK) {
					chdir(fobj->myPath);	
					ExecComm(Editor, fobj->myFullPath);
					chdir(confdir);
				}
			}
		}
	}
}

void mfinderapp::OpenWith(MFinderWin *win)
{
	dialog = new Dialog(0L, "Open With...", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
	if(!dialog->exec())
		return;

	if(win->viewtype == BYNAME) {
		ObjsListFrame *oframe = win->objslistframe;
		QList<FileListObj> selectedlist = oframe->selectedObjects();
		for(int i = 0; i < selectedlist.count(); i++) {
			FileListObj *fobj = selectedlist.at(i);
			if(fobj->myType != DR &&  fobj->myType != DRLNK && 
								fobj->myType != FILLNK && fobj->myType != FILEXELNK) {
				char *cmd = strdup(dialog->editfield->text());
				chdir(fobj->myPath);	
				ExecComm(cmd, fobj->myFullPath);
				chdir(confdir);
				free(cmd);
			}
		}
	} else {
		ObjsFrame *oframe = win->objsframe;
		for(int i = 0; i < oframe->list.count(); i++) {
			FileObj *fobj = oframe->list.at(i);
			if(fobj->isSelect) {
				if(fobj->myType != DR &&  fobj->myType != DRLNK && 
								fobj->myType != FILLNK && fobj->myType != FILEXELNK) {
					char *cmd = strdup(dialog->editfield->text());
					chdir(fobj->myPath);	
					ExecComm(cmd, fobj->myFullPath);
					chdir(confdir);
					free(cmd);
				}
			}
		}
	}
}

void mfinderapp::StartXTerm(MFinderWin *win)
{
	chdir(win->myPath);	
	ExecComm(Xterm, NULL);
	chdir(confdir);
}

void mfinderapp::InfoObj(MFinderWin *win)
{
	if(win->viewtype == BYNAME) {
		ObjsListFrame *oframe = win->objslistframe;
		QList<FileListObj> selectedlist = oframe->selectedObjects();
		for(int i = 0; i < selectedlist.count(); i++) {
			FileListObj *fobj = selectedlist.at(i);
				if(fobj->isSelect)
				 	fobj->InfoObj();
		}
	} else {
		ObjsFrame *oframe = win->objsframe;
		for(int i = 0; i < oframe->list.count(); i++) {
			FileObj *fobj = oframe->list.at(i);
			if(fobj->isSelect)
				fobj->InfoObj();
		}
	}
}

void mfinderapp::ExecComm(char *cmdline, char *arg)
{
	char cmd[MAX_NAME_LEN] = "";
	char buff[MAX_PATH_LEN] = "";
	char **argv = new char*[21];
	char *delims = " ";
	pid_t pid;
	Window win;
	XWindowAttributes attribs;
	time_t now;
	processMetaData *pmd = NULL;
	bool canexe = TRUE;
	XKeyEvent ev;
	XEvent xe;
	KeySym keysym;
	KeyCode keycode=0;

	sprintf(buff, "%s %s", cmdline, arg);  // the file is open with the same app
	for(int i = 0; i < processDict.count(); i++) {
		pmd = processDict.at(i);
		if(!pmd->waitappwin) {
			if(strcmp(pmd->cmdline, buff) == 0) {
				XSync(dspl, FALSE);
				if(!XGetWindowAttributes(dspl, pmd->win, &attribs)) {
					printf("closed processMetaData: %s\n", pmd->cmdline);
					processDict.removeRef(pmd);
					canexe = TRUE;
					break;
				} else {
					win = XmuClientWindow(dspl, pmd->win);
					if(attribs.map_state == IsUnmapped)
		 	   		XMapWindow(dspl, win);
					XRaiseWindow(dspl, win);
					canexe = FALSE;
					break;
				}
			} else {  							// the file is open with an other app
				if(strcmp(pmd->openfilepath, arg) == 0) {
					if(!XGetWindowAttributes(dspl, pmd->win, &attribs)) {
						printf("closed processMetaData: %s\n", pmd->cmdline);
						processDict.removeRef(pmd);
						canexe = TRUE;
						break;
					} else {
						sprintf(ERR, "The file \"%s\" is already open by \"%s\"\n"
												"Do you want to open it also with \"%s\"\n", 
											pmd->openfilename, pmd->appmdata->name, cmdline);
						canexe = FALSE;
						restoreOverrideCursor();
						dialog = new Dialog(0L, "Open", TRUE, 0, TRUE, TRUE, FALSE, TRUE, ERR);
						dialog->cancel->setText("Cancel");
						dialog->ok->setText("Open");
						if(dialog->exec()) 
							canexe = TRUE;
					}
				}
			}
		} else {  								// the file is opening with the same app 
			if(strcmp(pmd->cmdline, buff) == 0) {
				sprintf(ERR, "The file \"%s\" is already opening by \"%s\"\n"
										"wait a little!\n", pmd->openfilename, cmdline);
				restoreOverrideCursor();						
				dialog = new Dialog(0L, "Open", TRUE, 0, TRUE, TRUE, FALSE, FALSE, ERR);
				dialog->exec();
				canexe = FALSE;
				break;		
			} else {								// the file is opening with an other app
				if(strcmp(pmd->openfilepath, arg) == 0) {
					sprintf(ERR, "The file \"%s\" is already opening by \"%s\"\n"
											"Do you want to open it also with \"%s\"\n", 
										pmd->openfilename, pmd->appmdata->name, cmdline);
					canexe = FALSE;
					restoreOverrideCursor();
					dialog = new Dialog(0L, "Open", TRUE, 0, TRUE, TRUE, FALSE, TRUE, ERR);
					dialog->cancel->setText("Cancel");
					dialog->ok->setText("Open");
					if(dialog->exec()) 
						canexe = TRUE;
				}
			}
		}
	}

	if(canexe) {     									// the app is already open
		sprintf(cmd, "%s", cmdline);
		char *token = strtok(cmd, delims);
		bool mustbreak = FALSE;
		for(int i = 0; i < runappsDict.count(); i++) {
			if(mustbreak)
				break;
			runningApp *rna = runappsDict.at(i);
			if(strcmp(rna->appname, token) == 0) {
				for(int j = 0; j < appsDict.count(); j++) {
					appMetaData *app = appsDict.at(j);
					if(strcmp(app->name, rna->appname) == 0) {
						if(app->wmfaware) {
						
							XChangeProperty(dspl, DefaultRootWindow(dspl), 
								 					WMFOpenAtom, XA_STRING, 8,
		    										PropModeReplace, 
		    					 					(unsigned char *)arg, 
		    					 					strlen(arg)+1);
							kill(rna->pid, SIGUSR1);
					
							printf("sending SIGUSR1 to pid %i\n", rna->pid);

							processDict.append(new processMetaData());
							processMetaData *pmdnew = processDict.current();
							pmdnew->appmdata = app;
							sprintf(pmdnew->appname, "%s", argv[0]);
							sprintf(pmdnew->cmdline, "%s %s", cmdline, arg);
							strcpy(pmdnew->openfilepath, arg);
							strcpy(pmdnew->openfilename, lastPathComponent(arg));
							pmdnew->pid = rna->pid;
							time(&now);
							pmdnew->starttime = now;
							pmdnew->win = 0L;
							pmdnew->waitappwin = TRUE;
							pmdnew->ungrabbed = FALSE;

							canexe = FALSE;
							mustbreak = TRUE;
							break;
						}
					}	
				}	
			}
		}
	}
	
	if(canexe) {     									// the app is already open
		for(int i = 0; i < processDict.count(); i++) {
			pmd = processDict.at(i);
			if(strcmp(pmd->appmdata->name, cmdline) == 0) {
				if(pmd->appmdata->warnifopen) {
					
					if(!pmd->appmdata->wmfaware) {
				
						sprintf(ERR, "The app \"%s\" is already open!\n"
										"Do you want to open an other istance of it\n"
										"or open \"%s\" from the %s's Open Menu?\n", 
										pmd->appmdata->name, arg, pmd->appmdata->name);
						restoreOverrideCursor();				
						dialog = new Dialog(0L, "Open", TRUE, 0, TRUE, TRUE, FALSE, TRUE, ERR);
						dialog->cancel->setText("from menu");
						dialog->ok->setText("New");
						if(dialog->exec()) {
							canexe = TRUE;
							break;
						} else { 
							if(XGetWindowAttributes(dspl, pmd->win, &attribs)) {
								win = XmuClientWindow(dspl, pmd->win);
								if(attribs.map_state == IsUnmapped)
		 	   					XMapWindow(dspl, win);
								XRaiseWindow(dspl, win);
								ev.state = 0;
								if(pmd->appmdata->kctrl)		
									ev.state |= ControlMask;
								if(pmd->appmdata->kalt)		
									ev.state |= Mod1Mask;									
								if((keysym = XStringToKeysym(pmd->appmdata->keyopen)) != NoSymbol) {
									keycode = XKeysymToKeycode(dspl, keysym);					
									ev.keycode = keycode;
									ev.type = KeyPress;
									ev.window = win;
									if(ev.keycode != 0)
										XSendEvent(dspl, win, FALSE, 
																KeyPressMask,(XEvent *)&ev);
								}
								canexe = FALSE;
								break;
							}
						}
					}
				}
			}
		}
	}
		
	if(canexe) {
		sprintf(cmd, "%s", cmdline);
		char *token = strtok(cmd, delims);
		int argc = 0;
		argv[argc] = token;
		while(token != NULL && argc < 20) {
			argc++;
			token = strtok(NULL, delims);
			argv[argc] = token;
		}
		if(arg)
			argv[argc++] = arg;
		argv[argc] = (char *)0;

		time(&now);
		if((pid = fork()) < 0) {
			perror("fork");
		} else {
			if(pid == 0) {
         	freopen("/dev/null", "r", stdin);
				execvp(argv[0], argv);
				exit(1);
			} else {
				sleep(1);
				
				if(strcmp(cmdline, Xterm) != 0 && arg != NULL) {
					processDict.append(new processMetaData());
					processMetaData *pmd = processDict.current();
					pmd->appmdata = NULL;
					for(int i = 0; i < appsDict.count(); i++) {
						appMetaData *app = appsDict.at(i);
						if(strcmp(app->name, argv[0]) == 0) {
							pmd->appmdata = app;
							break;
						}
					}
					if(pmd->appmdata) {
						sprintf(pmd->appname, "%s", argv[0]);
						sprintf(pmd->cmdline, "%s %s", cmdline, arg);
						strcpy(pmd->openfilepath, arg);
						strcpy(pmd->openfilename, lastPathComponent(arg));
						pmd->pid = pid;
						pmd->starttime = now;
						pmd->win = 0L;
						pmd->waitappwin = TRUE;
						pmd->ungrabbed = FALSE;
					} else {
						processDict.removeRef(pmd);
					}
					runappsDict.append(new runningApp());
					runningApp *rna = runappsDict.current();
					sprintf(rna->appname, "%s", argv[0]);
					rna->pid = pid;
				}
				delete []argv;
     		}
 		}
	}
}

void mfinderapp::openAppWithFile(char *appname, char *filename, bool isfile)
{
	if(!isfile) {
		ExecComm(appname, NULL);
	} else {
		if(fileListDragObj != NULL)
			fileListDragObj->urlDragObj->~QUrlDrag();
		if(fileDragObj != NULL)
			fileDragObj->urlDragObj->~QUrlDrag();
		if(deskDragObj != NULL)
			deskDragObj->urlDragObj->~QUrlDrag();
		fileListDragObj = NULL;
		fileDragObj = NULL;
		deskDragObj = NULL;
		deskobjmoving = FALSE;	
		xdnddone = TRUE;	
		dndok	= FALSE;
		ExecComm(appname, filename);
	}	
}

void mfinderapp::offixDrop(QWidget *drSource)
{
	char sourcepath[MAX_PATH_LEN] = "";
	int sourcetype;
	QPoint pnt = QCursor::pos();
	Window target = 0, DispatchWindow = 0;
	XEvent Event;
	int lx = 0, ly = 0;
	bool dooffixdrop = FALSE;

	if(drSource->inherits("FileObj")) {	
		sprintf(sourcepath, "%s", ((FileObj*)drSource)->myFullPath);
		sourcetype = ((FileObj*)drSource)->myType;
	} 
	if(drSource->inherits("FileListObj")) {	
		sprintf(sourcepath, "%s", ((FileListObj*)drSource)->myFullPath);
		sourcetype = ((FileListObj*)drSource)->myType;
	}
	if(drSource->inherits("DeskObj")) {	
		sprintf(sourcepath, "%s", ((DeskObj*)drSource)->myFullPath);
		sourcetype = ((DeskObj*)drSource)->myType;
	}

	if(!XTranslateCoordinates(qt_xdisplay(), qt_xrootwin(), 
											qt_xrootwin(), pnt.x(), 
											pnt.y(), &lx, &ly, &target)) 
		goto cleardnd;
	if(target) {
		QWidget *w = widgetAt(pnt, TRUE);
		if(w == NULL) 
			dooffixdrop = TRUE;
	} else {
		target = appRootWin;
		dooffixdrop = TRUE;
	}
	if(dooffixdrop) {
		if(sourcetype == FIL || sourcetype == FILEXE || sourcetype == DR) {
			if(sourcetype == FIL)
				DataType = 2;
			if(sourcetype == FILEXE)
				DataType = 7;
			if(sourcetype == DR)
				DataType = 5;

			XChangeProperty(dspl, DefaultRootWindow(dspl), 
								 DndSelection, XA_STRING, 8,
		    					 PropModeReplace, 
		    					 (unsigned char *)sourcepath, 
		    					 strlen(sourcepath)+1);

			DataOK = TRUE;
			
			if(!XTranslateCoordinates(dspl, desktop()->winId(), desktop()->winId(),
													pnt.x(), pnt.y(), &lx, &ly, &Target)) {
				DataOK = FALSE;
				goto cleardnd;
			}

			if(!Target) {
				if(deskobjmoving) {
					deskDragObj->move(pnt.x(), pnt.y());
					deskDragObj->x = pnt.x();
					deskDragObj->y = pnt.y();
					removeDeskObjFromDict(deskDragObj->myFullPath);
					addDeskObjToDict(deskDragObj);
				} else {
					if(drSource->inherits("FileObj")) 
						makeDeskObjFromDrop(((FileObj*)drSource)->myFullPath, pnt.x(), pnt.y());		
					if(drSource->inherits("FileListObj")) 
						makeDeskObjFromDrop(((FileListObj*)drSource)->myFullPath, pnt.x(), pnt.y());		
					if(drSource->inherits("DeskObj")) 
						makeDeskObjFromDrop(((DeskObj*)drSource)->myFullPath, pnt.x(), pnt.y());		
					DataOK = FALSE;
					goto cleardnd;    // makeDeskObj() se c'e' gia' non lo fa !
				}
			}
			
			DispatchWindow = Target;
			if(DataType == 2) {
				Event.xclient.type = ClientMessage;
				Event.xclient.display = dspl;
				Event.xclient.message_type = DndProtocol;
				Event.xclient.format = 32;
				Event.xclient.window = Target;
				Event.xclient.data.l[0] = DataType;
      		Event.xclient.data.l[1] = 0;
      		Event.xclient.data.l[2] = 0;
				Event.xclient.data.l[3] = pnt.x() + 65536L*(long)pnt.y();
				Event.xclient.data.l[4] = 1;
				XSendEvent(dspl, DispatchWindow, TRUE, NoEventMask, &Event);
			}
			DataOK = FALSE;
		}
	}
	
cleardnd:
	fileListDragObj = NULL;
	fileDragObj = NULL;
	deskDragObj = NULL;
	isdragcopying = FALSE;
	deskobjmoving = FALSE;	
	xdnddone = TRUE;	
}

void mfinderapp::makeDeskObjFromDrop(char *dropobjpath, int x, int y)
{
	struct stat listStat;
	int type;
	bool exist = FALSE;
	char name[MAX_NAME_LEN] = "", path[MAX_PATH_LEN] = "", fpath[MAX_PATH_LEN] = "";
	 
	for(int i = 0; i < deskobjlist.count(); i++)
		if(strcmp(deskobjlist.at(i)->myFullPath, dropobjpath) == 0)
			exist = TRUE;
	if(!exist) {
		strcpy(fpath, dropobjpath);
		strcpy(path, deleteLastPathComponent(fpath));
		strcpy(name, lastPathComponent(fpath));
	
   	lstat(fpath, &listStat);
		if(S_ISREG(listStat.st_mode)) {
			if(listStat.st_mode & (S_IXUSR | S_IXGRP | S_IXOTH))
				type = FILEXE;
			else
				type = FIL;
		}
		if(S_ISDIR(listStat.st_mode)) 
			type = DR;
		if(S_ISLNK(listStat.st_mode)) {
			if(chdir(fpath) != 0) {
				if(listStat.st_mode & (S_IXUSR | S_IXGRP | S_IXOTH)) {
					type = FILEXELNK;
				} else {
					type = FILLNK;
				}
			} else {
				chdir(confdir);
				type = DRLNK;
			}
		}		
		if(S_ISCHR(listStat.st_mode)) 
			type = CHRDV;		
		if(S_ISBLK(listStat.st_mode)) 
			type = BLCKDV;	
		if(S_ISFIFO(listStat.st_mode)) 
			type = FIF;		
		if(S_ISSOCK(listStat.st_mode)) 
			type = SCKT;		

		deskobjlist.append(new DeskObj(0L, fpath, path, name, type, x, y));
		addDeskObjToDict(deskobjlist.current());
	}
}

void mfinderapp::makeDeskObjFromDictEntry(char *dictentry)
{
	char entry[2048] = "";
	char dsofullpath[MAX_PATH_LEN] = "";
	char dsopath[MAX_PATH_LEN] = "";
	char dsoname[MAX_NAME_LEN] = "";
	int dsotype, dsox, dsoy;
	char *token, *delims = "|";

	sprintf(entry, "%s", dictentry);
	token = strtok(entry, delims);
	strcpy(dsofullpath, token);
	token = strtok(NULL, delims);
	strcpy(dsopath, token);
	token = strtok(NULL, delims);
	strcpy(dsoname, token);
	token = strtok(NULL, delims);
	dsotype = atoi(token);
	token = strtok(NULL, delims);
	dsox = atoi(token);
	token = strtok(NULL, delims);
	dsoy = atoi(token);

	deskobjlist.append(new DeskObj(0L, dsofullpath, dsopath, dsoname, 
																		dsotype, dsox, dsoy));
	addDeskObjToDict(deskobjlist.current());
}

void mfinderapp::removeDeskObj(DeskObj *deskobj)
{
	int shFid = 0, shObid = 0;
	int m, t, q, k, sw, sh, x, y;
	short px[PIECES], py[PIECES];
	char pvx[PIECES], pvy[PIECES];
	char ax[PIECES], ay[PIECES];
	Display *scr;
	QPixmap Ptmp;

	Ptmp = QPixmap(deskobj->icona);
	Ptmp.detach();
	x = deskobj->pos().x();
	y = deskobj->pos().y();	

	removeDeskObjFromDict(deskobj->myFullPath);
	deskobjlist.removeRef(deskobj);

	scr = desktop()->x11Display();
	sw = desktop()->width();
	sh = desktop()->height();

	for(t=0, k=0; t < 48/PSIZE; t++) {
		for(q=0; q < 48/PSIZE; q++) {
	   	if(rand()%3) {
				ax[k] = t;
				ay[k] = q;
				px[k] = x + t * PSIZE;
				py[k] = y + q * PSIZE;
				pvx[k] = rand()%7 - 3;
				pvy[k] = -12 -rand()%6;
				k++;
	    	} else {
				ax[k] = -1;
	    	}
		}
	}
	q = k;
	while(k > 0) {
		for(t = 0; t < q; t++) {
	    	if(ax[t] >= 0) {
				px[t] += pvx[t];
				py[t] += pvy[t];
				pvy[t]++;
				if(px[t] < -48 || px[t] > sw || py[t] > sh) {
		    		ax[t] = -1;
		    		k--;
				} else {
		    		XCopyArea(scr, Ptmp.handle(), desktop()->winId(),
		    		DefaultGC(scr, 0),
			      						ax[t]*PSIZE, ay[t]*PSIZE, 
			      							PSIZE, PSIZE, px[t], py[t]);
				}
	    	}
		}
		for(t = 0; t < q; t++) {
			if(ax[t] >= 0) {
				XClearArea(scr, desktop()->winId(), px[t], py[t], PSIZE, PSIZE, 1);
	    	}
		}
	}
}
