#ifndef PROCSFRAME_H
#define PROCSFRAME_H

#ifdef __Linux__

#include <qwidget.h>
#include <qpainter.h> 
#include <qframe.h> 
#include <qimage.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h> 
#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <qkeycode.h>
#include <qapp.h>
#include <qevent.h> 
#include <qdrawutl.h>
#include "common.h"
#include "procobj.h"
#include "procs.h"
#include "procscntrls.h"
#include "dialogs.h"

int compid(const void *, const void *);

class ProcsFrame : public QWidget
{
	Q_OBJECT
public:
	ProcsFrame(QWidget *parent=0, const char *name=0, ProcsCntrls *contr=0);

	void readprocs();
	void makeProcTree(ProcObj *);
	QPixmap makeTransIcn(QImage);
	
	ProcObj *procobj[MAXPROC];
	ProcObj *pobjTmp[MAXPROC];
	int procspids[MAXPROC];
	int probjnum;
	int pnumtmp;
	
	QImage ImIcn, ImusrIcn, ImttyIcn, ImcmdIcn;
	QImage pixmask;
	QPixmap Icn, usrIcn, ttyIcn, cmdIcn;
	QPixmap IcnDeact, usrIcnDeact, ttyIcnDeact, cmdIcnDeact;
	
	int unum;
	ProcsCntrls *contr;
	char currusr[32];

	Dialog *dialog;	
	
signals:
	void resizeDone(int);
	
public slots:
	void DeselOthers(int);
	void reloadProcs();
	void killProc();
	void ShowUnUsrProcs(const char *);
		
protected:
	void resizeEvent(QResizeEvent *);
	void closeEvent(QCloseEvent *);       
	void paintEvent(QPaintEvent *);

private:

};

#endif 
#endif 
